### MessageBox组件

#### 组件内容
目前只包含以下几个, 会不断进行扩展
* MessageBox.SMS()

#### 如何使用
npm
```shell
## 未安装package
npm install hello-ui --save-dev
## 已安装package
npm update hello-ui --save-dev
```
import as module
```js
import 'node_modules/hello-ui/dist/components/MessageBox/MessageBox.css';
import {MessageBox} from 'hello-ui';
MessageBox.SMS();
```

### API
暂无

### Example
[功能预览](https://qiuguorong.github.io/hello-ui/dist/#/messagebox)
[具体实现](https://github.com/qiuguorong/hello-ui/blob/master/src/views/MessageBox.vue)
```js
// 用法如下
// 注意提交的时候,根据业务情况自行调动this.close关闭对话框
MessageBox.SMS({
  title: '短信验证码',
  placeholder: '请输入短信验证码',
  maxLength: 6, // input最大长度
  counter: 10, // 倒计时
  // 点击获取验证码触发
  onSend: function () {
    console.log('send');
  },
  // input输入时触发
  onInput: function (value) {
    console.log(value);
  },
  // 点击取消按钮触发
  onCancel: function () {
    console.log('cancel');
  },
  // 点击提交按钮触发
  onSubmit: function () {
    console.log('submit');
    this.setWrong();
    // this.close();
  }
});
```

### 设备兼容
暂无
