(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("Hello", [], factory);
	else if(typeof exports === 'object')
		exports["Hello"] = factory();
	else
		root["Hello"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 32);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var utils = {
  support: {
    touch: function () {
      // eslint-disable-next-line
      return !!('ontouchstart' in window || window.DocumentTouch && document instanceof DocumentTouch);
    }()
  },
  env: {
    isWechat: /MicroMessenger/i.test(navigator.userAgent),
    isWeiyi: /WeiYi/i.test(navigator.userAgent),
    isIos: /(iPhone|iPad|iPod)/.test(navigator.userAgent),
    isAndroid: /Android/.test(navigator.userAgent)
  },
  now: function now() {
    return new Date().getTime();
  },
  getRandom: function getRandom(min, max) {
    var range = max - min;
    var rand = Math.random();
    return min + Math.round(rand * range);
  },
  getUnique: function getUnique() {
    var unique = '';
    unique = this.now() + '_' + this.getRandom(0, 10000);
    return unique;
  },
  hasClass: function hasClass(obj, cls) {
    return obj.className.match(new RegExp(cls));
  },
  addClass: function addClass(obj, cls) {
    if (!this.hasClass(obj, cls)) obj.className += ' ' + cls;
  },
  removeClass: function removeClass(obj, cls) {
    if (this.hasClass(obj, cls)) {
      var reg = new RegExp('(\\s|^)' + cls);
      obj.className = obj.className.replace(reg, '');
    }
  },
  noop: function noop() {},
  // 创建debug DOM
  createDebug: function createDebug() {
    var div = document.createElement('div');
    div.id = 'debug';
    div.style.position = 'fixed';
    div.style.top = '0px';
    div.style.left = '0px';
    div.style.right = '0px';
    div.style.zIndex = '9999';
    div.style.backgroundColor = 'rgba(0,0,0,0.8)';
    div.style.color = '#FFF';
    div.style.wordBreak = 'break-all';
    div.style.wordWrap = 'break-word';
    div.style.overflowY = 'scroll';
    div.style.fontSize = '10px';
    document.body.appendChild(div);
  },
  // 向debug DOM添加元素
  appendDebug: function appendDebug(element, text, color) {
    var debug = document.getElementById('debug');
    var item = document.createElement(element);
    color = color || '#FFF';
    item.style.color = color;
    item.innerText = text;
    console.log(text);
    debug.appendChild(item);
  },
  // 是否是百分比数值
  isPercentage: function isPercentage(value) {
    value = value + '';
    if (value.indexOf('%') !== -1) {
      return true;
    }
    return false;
  },
  // 百分比转小数
  percentageToNumber: function percentageToNumber(value) {
    value = value + '';
    if (value.indexOf('%') !== -1) {
      value = parseFloat(value.replace('%', '')).toFixed(2);
      return (value / 100).toFixed(2);
    }
    return value;
  },
  // 获取viewport content中的参数
  getViewPortParam: function getViewPortParam(name) {
    var viewport = document.querySelector('meta[name=viewport]');
    if (!viewport) {
      return null;
    }
    var content = viewport.getAttribute('content');
    if (!content) {
      return null;
    }
    // eslint-disable-next-line
    name = name.replace(/[\[]/, '\\[').replace(/[\]]/, '\\]');
    var regex = new RegExp('(^|,)' + name + '=([^,]*)(,|$)', 'i');
    var results = regex.exec(content);
    return results === null ? null : decodeURIComponent(results[2].replace(/\+/g, ' '));
  },
  // 根据viewport设置放大倍数,默认为1
  getScale: function getScale() {
    var initialScale = this.getViewPortParam('initial-scale') || 0;
    var maximumScale = this.getViewPortParam('maximum-scale') || 0;
    var minimumScale = this.getViewPortParam('minimum-scale') || 0;
    var scale = initialScale;
    if (maximumScale !== 0 && maximumScale <= initialScale) {
      scale = maximumScale;
    }
    if (minimumScale !== 0 && minimumScale >= initialScale) {
      scale = minimumScale;
    }
    return scale === 0 ? 1 : 1.0 / scale;
  }
};
exports.default = utils;
module.exports = exports['default'];

/***/ }),
/* 1 */
/***/ (function(module, exports) {

// https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
var global = module.exports = typeof window != 'undefined' && window.Math == Math
  ? window : typeof self != 'undefined' && self.Math == Math ? self
  // eslint-disable-next-line no-new-func
  : Function('return this')();
if (typeof __g == 'number') __g = global; // eslint-disable-line no-undef


/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
// 事件总线
var EventBus = function EventBus(unique) {
  this.unique = unique || new Date().getTime();
  this.topics = {};
};
EventBus.prototype.on = function (topic, func) {
  var cbs = this.topics[this.unique + topic];
  cbs ? cbs.push(func) : this.topics[this.unique + topic] = [];
  if (!cbs) {
    this.topics[this.unique + topic].push(func);
  }
};
EventBus.prototype.emit = function (topic) {
  var cbs = this.topics[this.unique + topic];
  var args = Array.prototype.slice.call(arguments, 1);
  if (cbs) {
    for (var i = 0; i < cbs.length; i++) {
      cbs[i].apply(this, args);
    }
  }
};
EventBus.prototype.off = function (topic) {
  var cbs = this.topics[this.unique + topic];
  if (cbs) {
    var i = cbs.length;
    while (i--) {
      cbs.splice(i, 1);
    }
  }
};

exports.default = {
  eventBuses: [],
  create: function create(unique) {
    for (var i = 0; i < this.eventBuses.length; i++) {
      if (this.eventBuses[i].unique === unique) {
        return this.eventBuses[i];
      }
    }
    var eventBus = new EventBus(unique);
    this.eventBuses.push(eventBus);
    return eventBus;
  }
};
module.exports = exports["default"];

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
// 来源 object-assign
// https://github.com/sindresorhus/object-assign/edit/master/index.js



Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getOwnPropertySymbols = __webpack_require__(36);

var _getOwnPropertySymbols2 = _interopRequireDefault(_getOwnPropertySymbols);

exports.default = function (target, source) {
  var from;
  var to = toObject(target);
  var symbols;

  for (var s = 1; s < arguments.length; s++) {
    from = Object(arguments[s]);

    for (var key in from) {
      if (hasOwnProperty.call(from, key)) {
        to[key] = from[key];
      }
    }

    if (getOwnPropertySymbols) {
      symbols = getOwnPropertySymbols(from);
      for (var i = 0; i < symbols.length; i++) {
        if (propIsEnumerable.call(from, symbols[i])) {
          to[symbols[i]] = from[symbols[i]];
        }
      }
    }
  }

  return to;
};

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getOwnPropertySymbols = _getOwnPropertySymbols2.default;
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;

function toObject(val) {
  if (val === null || val === undefined) {
    throw new TypeError('Object.assign cannot be called with null or undefined');
  }
  return Object(val);
}

;
module.exports = exports['default'];

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

// Thank's IE8 for his funny defineProperty
module.exports = !__webpack_require__(8)(function () {
  return Object.defineProperty({}, 'a', { get: function () { return 7; } }).a != 7;
});


/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

var anObject = __webpack_require__(9);
var IE8_DOM_DEFINE = __webpack_require__(21);
var toPrimitive = __webpack_require__(14);
var dP = Object.defineProperty;

exports.f = __webpack_require__(4) ? Object.defineProperty : function defineProperty(O, P, Attributes) {
  anObject(O);
  P = toPrimitive(P, true);
  anObject(Attributes);
  if (IE8_DOM_DEFINE) try {
    return dP(O, P, Attributes);
  } catch (e) { /* empty */ }
  if ('get' in Attributes || 'set' in Attributes) throw TypeError('Accessors not supported!');
  if ('value' in Attributes) O[P] = Attributes.value;
  return O;
};


/***/ }),
/* 6 */
/***/ (function(module, exports) {

var hasOwnProperty = {}.hasOwnProperty;
module.exports = function (it, key) {
  return hasOwnProperty.call(it, key);
};


/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

// to indexed object, toObject with fallback for non-array-like ES3 strings
var IObject = __webpack_require__(47);
var defined = __webpack_require__(48);
module.exports = function (it) {
  return IObject(defined(it));
};


/***/ }),
/* 8 */
/***/ (function(module, exports) {

module.exports = function (exec) {
  try {
    return !!exec();
  } catch (e) {
    return true;
  }
};


/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

var isObject = __webpack_require__(10);
module.exports = function (it) {
  if (!isObject(it)) throw TypeError(it + ' is not an object!');
  return it;
};


/***/ }),
/* 10 */
/***/ (function(module, exports) {

module.exports = function (it) {
  return typeof it === 'object' ? it !== null : typeof it === 'function';
};


/***/ }),
/* 11 */
/***/ (function(module, exports) {

var id = 0;
var px = Math.random();
module.exports = function (key) {
  return 'Symbol('.concat(key === undefined ? '' : key, ')_', (++id + px).toString(36));
};


/***/ }),
/* 12 */
/***/ (function(module, exports) {

var core = module.exports = { version: '2.5.1' };
if (typeof __e == 'number') __e = core; // eslint-disable-line no-undef


/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

var dP = __webpack_require__(5);
var createDesc = __webpack_require__(15);
module.exports = __webpack_require__(4) ? function (object, key, value) {
  return dP.f(object, key, createDesc(1, value));
} : function (object, key, value) {
  object[key] = value;
  return object;
};


/***/ }),
/* 14 */
/***/ (function(module, exports, __webpack_require__) {

// 7.1.1 ToPrimitive(input [, PreferredType])
var isObject = __webpack_require__(10);
// instead of the ES6 spec version, we didn't implement @@toPrimitive case
// and the second argument - flag - preferred type is a string
module.exports = function (it, S) {
  if (!isObject(it)) return it;
  var fn, val;
  if (S && typeof (fn = it.toString) == 'function' && !isObject(val = fn.call(it))) return val;
  if (typeof (fn = it.valueOf) == 'function' && !isObject(val = fn.call(it))) return val;
  if (!S && typeof (fn = it.toString) == 'function' && !isObject(val = fn.call(it))) return val;
  throw TypeError("Can't convert object to primitive value");
};


/***/ }),
/* 15 */
/***/ (function(module, exports) {

module.exports = function (bitmap, value) {
  return {
    enumerable: !(bitmap & 1),
    configurable: !(bitmap & 2),
    writable: !(bitmap & 4),
    value: value
  };
};


/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

var global = __webpack_require__(1);
var SHARED = '__core-js_shared__';
var store = global[SHARED] || (global[SHARED] = {});
module.exports = function (key) {
  return store[key] || (store[key] = {});
};


/***/ }),
/* 17 */
/***/ (function(module, exports, __webpack_require__) {

var store = __webpack_require__(16)('wks');
var uid = __webpack_require__(11);
var Symbol = __webpack_require__(1).Symbol;
var USE_SYMBOL = typeof Symbol == 'function';

var $exports = module.exports = function (name) {
  return store[name] || (store[name] =
    USE_SYMBOL && Symbol[name] || (USE_SYMBOL ? Symbol : uid)('Symbol.' + name));
};

$exports.store = store;


/***/ }),
/* 18 */
/***/ (function(module, exports, __webpack_require__) {

// 19.1.2.14 / 15.2.3.14 Object.keys(O)
var $keys = __webpack_require__(25);
var enumBugKeys = __webpack_require__(19);

module.exports = Object.keys || function keys(O) {
  return $keys(O, enumBugKeys);
};


/***/ }),
/* 19 */
/***/ (function(module, exports) {

// IE 8- don't enum bug keys
module.exports = (
  'constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf'
).split(',');


/***/ }),
/* 20 */
/***/ (function(module, exports) {

exports.f = {}.propertyIsEnumerable;


/***/ }),
/* 21 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = !__webpack_require__(4) && !__webpack_require__(8)(function () {
  return Object.defineProperty(__webpack_require__(22)('div'), 'a', { get: function () { return 7; } }).a != 7;
});


/***/ }),
/* 22 */
/***/ (function(module, exports, __webpack_require__) {

var isObject = __webpack_require__(10);
var document = __webpack_require__(1).document;
// typeof document.createElement is 'object' in old IE
var is = isObject(document) && isObject(document.createElement);
module.exports = function (it) {
  return is ? document.createElement(it) : {};
};


/***/ }),
/* 23 */
/***/ (function(module, exports, __webpack_require__) {

exports.f = __webpack_require__(17);


/***/ }),
/* 24 */
/***/ (function(module, exports) {

module.exports = true;


/***/ }),
/* 25 */
/***/ (function(module, exports, __webpack_require__) {

var has = __webpack_require__(6);
var toIObject = __webpack_require__(7);
var arrayIndexOf = __webpack_require__(49)(false);
var IE_PROTO = __webpack_require__(28)('IE_PROTO');

module.exports = function (object, names) {
  var O = toIObject(object);
  var i = 0;
  var result = [];
  var key;
  for (key in O) if (key != IE_PROTO) has(O, key) && result.push(key);
  // Don't enum bug & hidden keys
  while (names.length > i) if (has(O, key = names[i++])) {
    ~arrayIndexOf(result, key) || result.push(key);
  }
  return result;
};


/***/ }),
/* 26 */
/***/ (function(module, exports) {

var toString = {}.toString;

module.exports = function (it) {
  return toString.call(it).slice(8, -1);
};


/***/ }),
/* 27 */
/***/ (function(module, exports) {

// 7.1.4 ToInteger
var ceil = Math.ceil;
var floor = Math.floor;
module.exports = function (it) {
  return isNaN(it = +it) ? 0 : (it > 0 ? floor : ceil)(it);
};


/***/ }),
/* 28 */
/***/ (function(module, exports, __webpack_require__) {

var shared = __webpack_require__(16)('keys');
var uid = __webpack_require__(11);
module.exports = function (key) {
  return shared[key] || (shared[key] = uid(key));
};


/***/ }),
/* 29 */
/***/ (function(module, exports) {

exports.f = Object.getOwnPropertySymbols;


/***/ }),
/* 30 */
/***/ (function(module, exports, __webpack_require__) {

// 19.1.2.7 / 15.2.3.4 Object.getOwnPropertyNames(O)
var $keys = __webpack_require__(25);
var hiddenKeys = __webpack_require__(19).concat('length', 'prototype');

exports.f = Object.getOwnPropertyNames || function getOwnPropertyNames(O) {
  return $keys(O, hiddenKeys);
};


/***/ }),
/* 31 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
// 嗅探transform可支持的前缀
var _elementStyle = document.createElement('div').style;
var _vendor = function () {
  var vendors = ['t', 'webkitT', 'MozT', 'msT', 'OT'];
  var transform;
  var i = 0;
  var l = vendors.length;
  for (; i < l; i++) {
    transform = vendors[i] + 'ransform';
    if (transform in _elementStyle) return vendors[i].substr(0, vendors[i].length - 1);
  }

  return false;
}();
var _prefixStyle = function _prefixStyle(style) {
  if (_vendor === false) return false;
  if (_vendor === '') return style;
  return _vendor + style.charAt(0).toUpperCase() + style.substr(1);
};

var transition = {
  prefixStyle: _prefixStyle,
  transform: _prefixStyle('transform'),
  transformProperty: _prefixStyle('transitionProperty'),
  transitionDuration: _prefixStyle('transitionDuration'),
  transitionTimingFunction: _prefixStyle('transitionTimingFunction'),
  // 设置transition属性
  setProperty: function setProperty(obj, property) {
    obj.style[_prefixStyle('transitionProperty')] = property;
  },
  // 页面滑动到指定位置
  setTransform: function setTransform(obj, x, y) {
    obj.style[_prefixStyle('transform')] = 'translate3d(' + x + 'px,' + y + 'px, 0px)';
  },
  // 设置transition间隔时间
  setDuration: function setDuration(obj, time) {
    obj.style[_prefixStyle('transitionDuration')] = time + 'ms';
  },
  // 设置scale
  setScale: function setScale(obj, scale) {
    obj.style[_prefixStyle('transform')] = 'scale(' + scale + ')';
  },
  // 设置transition的动画贝塞尔曲线
  setTimingFunction: function setTimingFunction(obj, easing) {
    obj.style[_prefixStyle('transitionTimingFunction')] = easing;
  }
};
exports.default = transition;
module.exports = exports['default'];

/***/ }),
/* 32 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

__webpack_require__(33);

var _messagebox = __webpack_require__(34);

var _messagebox2 = _interopRequireDefault(_messagebox);

var _loading = __webpack_require__(59);

var _loading2 = _interopRequireDefault(_loading);

var _audioplayer = __webpack_require__(64);

var _audioplayer2 = _interopRequireDefault(_audioplayer);

var _swiper = __webpack_require__(66);

var _swiper2 = _interopRequireDefault(_swiper);

var _tab = __webpack_require__(68);

var _tab2 = _interopRequireDefault(_tab);

var _signature = __webpack_require__(70);

var _signature2 = _interopRequireDefault(_signature);

var _uploader = __webpack_require__(71);

var _uploader2 = _interopRequireDefault(_uploader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  MessageBox: _messagebox2.default,
  Loading: _loading2.default,
  Audioplayer: _audioplayer2.default,
  Swiper: _swiper2.default,
  Tab: _tab2.default,
  Signature: _signature2.default,
  Uploader: _uploader2.default
};
module.exports = exports['default'];

/***/ }),
/* 33 */
/***/ (function(module, exports) {

// removed by extract-text-webpack-plugin

/***/ }),
/* 34 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

__webpack_require__(35);

var _utils = __webpack_require__(0);

var _utils2 = _interopRequireDefault(_utils);

var _eventBus = __webpack_require__(2);

var _eventBus2 = _interopRequireDefault(_eventBus);

var _extends = __webpack_require__(3);

var _extends2 = _interopRequireDefault(_extends);

var _messageboxSms = __webpack_require__(58);

var _messageboxSms2 = _interopRequireDefault(_messageboxSms);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MessageBox = function MessageBox(html, options) {
  var defaults = {
    title: null,
    message: null,
    buttons: []
  };
  this.options = defaults;
  (0, _extends2.default)(this.options, options);
  this.unique = this.options.unique || _utils2.default.getUnique();
  this.html = html;
  this._init();
};
MessageBox.prototype = {
  _init: function _init() {
    var self = this;
    self.observer = _eventBus2.default.create(self.unique);
    self._appendBody(self.html);
    self._addEvent();
  },
  _createElement: function _createElement(html) {
    var div = document.createElement('div');
    div.innerHTML = html;
    return div;
  },
  _appendBody: function _appendBody(html) {
    var self = this;
    self.$el = self._createElement(html);
    document.body.appendChild(self.$el);
  },
  _addEvent: function _addEvent() {
    var self = this;
    var buttons = self.options.buttons;
    var $dom = null;
    for (var i = 0; i < buttons.length; i++) {
      $dom = self.$el.querySelector(buttons[i].el);
      if ($dom) {
        (function (index, _self) {
          $dom.addEventListener('click', function () {
            buttons[index].callback && buttons[index].callback.apply(_self, Array.prototype.slice.call(arguments));
            buttons[index].close && self.close();
          }, false);
        })(i, self);
      }
    }
    for (var item in self.options) {
      if (item.indexOf('on') === 0) {
        if (self.options[item] instanceof Function) {
          (function (item, _self) {
            _self.observer.on(item, function () {
              _self.options[item].apply(_self, Array.prototype.slice.call(arguments));
            });
          })(item, self);
        }
      }
    }
  },
  close: function close() {
    var self = this;
    document.body.removeChild(self.$el);
  }
};

MessageBox.SMS = function (options) {
  var defaults = {
    title: '短信验证码',
    placeholder: '请输入短信验证码',
    maxLength: 6,
    counter: 10,
    onSend: _utils2.default.noop,
    onInput: _utils2.default.noop,
    onCancel: _utils2.default.noop,
    onSubmit: _utils2.default.noop
  };
  var config = {};
  config = (0, _extends2.default)(defaults, options);
  config.buttons = [];
  config.buttons.push({
    el: '.js-btn-sms',
    callback: function callback() {
      this.observer.emit('onSend');
      startTimer(this.$el);
    }
  });
  config.buttons.push({
    el: '.js-btn-cancel',
    close: true,
    callback: function callback() {
      this.observer.emit('onCancel');
    }
  });
  config.buttons.push({
    el: '.js-btn-submit',
    callback: function callback() {
      this.observer.emit('onSubmit');
    }
  });
  var instance = new MessageBox(_messageboxSms2.default, config);
  var $input = instance.$el.querySelector('.bx-sms-input');
  instance.$el.querySelector('.bx-modal-title').innerText = config.title;
  $input.setAttribute('placeholder', config.placeholder);
  $input.setAttribute('maxlength', config.maxLength);
  instance.$el.querySelector('.bx-sms-count').innerText = config.counter;
  $input.addEventListener('input', function () {
    var value = instance.$el.querySelector('.bx-sms-input').value;
    instance.observer.emit('onInput', value);
    if (value === '') {
      _utils2.default.removeClass($input, 'bx-sms-input--error');
    }
  });
  instance.setWrong = function () {
    _utils2.default.addClass($input, 'bx-sms-input--error');
  };
  return instance;
};

var startTimer = function startTimer(el) {
  var $btnSMS = el.querySelector('.js-btn-sms');
  var $btnSMSDisable = el.querySelector('.bx-sms-btn--disable');
  var $smsCount = el.querySelector('.bx-sms-count');
  $btnSMS.style.display = 'none';
  $btnSMSDisable.style.display = 'block';
  var counter = $smsCount.innerText;
  var originalCounter = counter;
  counter = parseInt(counter);
  var timer = window.setInterval(function () {
    counter--;
    $smsCount.innerText = counter;
    if (counter === 0) {
      window.clearInterval(timer);
      timer = null;
      $smsCount.innerText = originalCounter;
      $btnSMS.innerText = '重新获取';
      $btnSMS.style.display = 'block';
      $btnSMSDisable.style.display = 'none';
    }
  }, 1000);
};

exports.default = MessageBox;
module.exports = exports['default'];

/***/ }),
/* 35 */
/***/ (function(module, exports) {

// removed by extract-text-webpack-plugin

/***/ }),
/* 36 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = { "default": __webpack_require__(37), __esModule: true };

/***/ }),
/* 37 */
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(38);
module.exports = __webpack_require__(12).Object.getOwnPropertySymbols;


/***/ }),
/* 38 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

// ECMAScript 6 symbols shim
var global = __webpack_require__(1);
var has = __webpack_require__(6);
var DESCRIPTORS = __webpack_require__(4);
var $export = __webpack_require__(39);
var redefine = __webpack_require__(42);
var META = __webpack_require__(43).KEY;
var $fails = __webpack_require__(8);
var shared = __webpack_require__(16);
var setToStringTag = __webpack_require__(44);
var uid = __webpack_require__(11);
var wks = __webpack_require__(17);
var wksExt = __webpack_require__(23);
var wksDefine = __webpack_require__(45);
var enumKeys = __webpack_require__(46);
var isArray = __webpack_require__(52);
var anObject = __webpack_require__(9);
var toIObject = __webpack_require__(7);
var toPrimitive = __webpack_require__(14);
var createDesc = __webpack_require__(15);
var _create = __webpack_require__(53);
var gOPNExt = __webpack_require__(56);
var $GOPD = __webpack_require__(57);
var $DP = __webpack_require__(5);
var $keys = __webpack_require__(18);
var gOPD = $GOPD.f;
var dP = $DP.f;
var gOPN = gOPNExt.f;
var $Symbol = global.Symbol;
var $JSON = global.JSON;
var _stringify = $JSON && $JSON.stringify;
var PROTOTYPE = 'prototype';
var HIDDEN = wks('_hidden');
var TO_PRIMITIVE = wks('toPrimitive');
var isEnum = {}.propertyIsEnumerable;
var SymbolRegistry = shared('symbol-registry');
var AllSymbols = shared('symbols');
var OPSymbols = shared('op-symbols');
var ObjectProto = Object[PROTOTYPE];
var USE_NATIVE = typeof $Symbol == 'function';
var QObject = global.QObject;
// Don't use setters in Qt Script, https://github.com/zloirock/core-js/issues/173
var setter = !QObject || !QObject[PROTOTYPE] || !QObject[PROTOTYPE].findChild;

// fallback for old Android, https://code.google.com/p/v8/issues/detail?id=687
var setSymbolDesc = DESCRIPTORS && $fails(function () {
  return _create(dP({}, 'a', {
    get: function () { return dP(this, 'a', { value: 7 }).a; }
  })).a != 7;
}) ? function (it, key, D) {
  var protoDesc = gOPD(ObjectProto, key);
  if (protoDesc) delete ObjectProto[key];
  dP(it, key, D);
  if (protoDesc && it !== ObjectProto) dP(ObjectProto, key, protoDesc);
} : dP;

var wrap = function (tag) {
  var sym = AllSymbols[tag] = _create($Symbol[PROTOTYPE]);
  sym._k = tag;
  return sym;
};

var isSymbol = USE_NATIVE && typeof $Symbol.iterator == 'symbol' ? function (it) {
  return typeof it == 'symbol';
} : function (it) {
  return it instanceof $Symbol;
};

var $defineProperty = function defineProperty(it, key, D) {
  if (it === ObjectProto) $defineProperty(OPSymbols, key, D);
  anObject(it);
  key = toPrimitive(key, true);
  anObject(D);
  if (has(AllSymbols, key)) {
    if (!D.enumerable) {
      if (!has(it, HIDDEN)) dP(it, HIDDEN, createDesc(1, {}));
      it[HIDDEN][key] = true;
    } else {
      if (has(it, HIDDEN) && it[HIDDEN][key]) it[HIDDEN][key] = false;
      D = _create(D, { enumerable: createDesc(0, false) });
    } return setSymbolDesc(it, key, D);
  } return dP(it, key, D);
};
var $defineProperties = function defineProperties(it, P) {
  anObject(it);
  var keys = enumKeys(P = toIObject(P));
  var i = 0;
  var l = keys.length;
  var key;
  while (l > i) $defineProperty(it, key = keys[i++], P[key]);
  return it;
};
var $create = function create(it, P) {
  return P === undefined ? _create(it) : $defineProperties(_create(it), P);
};
var $propertyIsEnumerable = function propertyIsEnumerable(key) {
  var E = isEnum.call(this, key = toPrimitive(key, true));
  if (this === ObjectProto && has(AllSymbols, key) && !has(OPSymbols, key)) return false;
  return E || !has(this, key) || !has(AllSymbols, key) || has(this, HIDDEN) && this[HIDDEN][key] ? E : true;
};
var $getOwnPropertyDescriptor = function getOwnPropertyDescriptor(it, key) {
  it = toIObject(it);
  key = toPrimitive(key, true);
  if (it === ObjectProto && has(AllSymbols, key) && !has(OPSymbols, key)) return;
  var D = gOPD(it, key);
  if (D && has(AllSymbols, key) && !(has(it, HIDDEN) && it[HIDDEN][key])) D.enumerable = true;
  return D;
};
var $getOwnPropertyNames = function getOwnPropertyNames(it) {
  var names = gOPN(toIObject(it));
  var result = [];
  var i = 0;
  var key;
  while (names.length > i) {
    if (!has(AllSymbols, key = names[i++]) && key != HIDDEN && key != META) result.push(key);
  } return result;
};
var $getOwnPropertySymbols = function getOwnPropertySymbols(it) {
  var IS_OP = it === ObjectProto;
  var names = gOPN(IS_OP ? OPSymbols : toIObject(it));
  var result = [];
  var i = 0;
  var key;
  while (names.length > i) {
    if (has(AllSymbols, key = names[i++]) && (IS_OP ? has(ObjectProto, key) : true)) result.push(AllSymbols[key]);
  } return result;
};

// 19.4.1.1 Symbol([description])
if (!USE_NATIVE) {
  $Symbol = function Symbol() {
    if (this instanceof $Symbol) throw TypeError('Symbol is not a constructor!');
    var tag = uid(arguments.length > 0 ? arguments[0] : undefined);
    var $set = function (value) {
      if (this === ObjectProto) $set.call(OPSymbols, value);
      if (has(this, HIDDEN) && has(this[HIDDEN], tag)) this[HIDDEN][tag] = false;
      setSymbolDesc(this, tag, createDesc(1, value));
    };
    if (DESCRIPTORS && setter) setSymbolDesc(ObjectProto, tag, { configurable: true, set: $set });
    return wrap(tag);
  };
  redefine($Symbol[PROTOTYPE], 'toString', function toString() {
    return this._k;
  });

  $GOPD.f = $getOwnPropertyDescriptor;
  $DP.f = $defineProperty;
  __webpack_require__(30).f = gOPNExt.f = $getOwnPropertyNames;
  __webpack_require__(20).f = $propertyIsEnumerable;
  __webpack_require__(29).f = $getOwnPropertySymbols;

  if (DESCRIPTORS && !__webpack_require__(24)) {
    redefine(ObjectProto, 'propertyIsEnumerable', $propertyIsEnumerable, true);
  }

  wksExt.f = function (name) {
    return wrap(wks(name));
  };
}

$export($export.G + $export.W + $export.F * !USE_NATIVE, { Symbol: $Symbol });

for (var es6Symbols = (
  // 19.4.2.2, 19.4.2.3, 19.4.2.4, 19.4.2.6, 19.4.2.8, 19.4.2.9, 19.4.2.10, 19.4.2.11, 19.4.2.12, 19.4.2.13, 19.4.2.14
  'hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables'
).split(','), j = 0; es6Symbols.length > j;)wks(es6Symbols[j++]);

for (var wellKnownSymbols = $keys(wks.store), k = 0; wellKnownSymbols.length > k;) wksDefine(wellKnownSymbols[k++]);

$export($export.S + $export.F * !USE_NATIVE, 'Symbol', {
  // 19.4.2.1 Symbol.for(key)
  'for': function (key) {
    return has(SymbolRegistry, key += '')
      ? SymbolRegistry[key]
      : SymbolRegistry[key] = $Symbol(key);
  },
  // 19.4.2.5 Symbol.keyFor(sym)
  keyFor: function keyFor(sym) {
    if (!isSymbol(sym)) throw TypeError(sym + ' is not a symbol!');
    for (var key in SymbolRegistry) if (SymbolRegistry[key] === sym) return key;
  },
  useSetter: function () { setter = true; },
  useSimple: function () { setter = false; }
});

$export($export.S + $export.F * !USE_NATIVE, 'Object', {
  // 19.1.2.2 Object.create(O [, Properties])
  create: $create,
  // 19.1.2.4 Object.defineProperty(O, P, Attributes)
  defineProperty: $defineProperty,
  // 19.1.2.3 Object.defineProperties(O, Properties)
  defineProperties: $defineProperties,
  // 19.1.2.6 Object.getOwnPropertyDescriptor(O, P)
  getOwnPropertyDescriptor: $getOwnPropertyDescriptor,
  // 19.1.2.7 Object.getOwnPropertyNames(O)
  getOwnPropertyNames: $getOwnPropertyNames,
  // 19.1.2.8 Object.getOwnPropertySymbols(O)
  getOwnPropertySymbols: $getOwnPropertySymbols
});

// 24.3.2 JSON.stringify(value [, replacer [, space]])
$JSON && $export($export.S + $export.F * (!USE_NATIVE || $fails(function () {
  var S = $Symbol();
  // MS Edge converts symbol values to JSON as {}
  // WebKit converts symbol values to JSON as null
  // V8 throws on boxed symbols
  return _stringify([S]) != '[null]' || _stringify({ a: S }) != '{}' || _stringify(Object(S)) != '{}';
})), 'JSON', {
  stringify: function stringify(it) {
    if (it === undefined || isSymbol(it)) return; // IE8 returns string on undefined
    var args = [it];
    var i = 1;
    var replacer, $replacer;
    while (arguments.length > i) args.push(arguments[i++]);
    replacer = args[1];
    if (typeof replacer == 'function') $replacer = replacer;
    if ($replacer || !isArray(replacer)) replacer = function (key, value) {
      if ($replacer) value = $replacer.call(this, key, value);
      if (!isSymbol(value)) return value;
    };
    args[1] = replacer;
    return _stringify.apply($JSON, args);
  }
});

// 19.4.3.4 Symbol.prototype[@@toPrimitive](hint)
$Symbol[PROTOTYPE][TO_PRIMITIVE] || __webpack_require__(13)($Symbol[PROTOTYPE], TO_PRIMITIVE, $Symbol[PROTOTYPE].valueOf);
// 19.4.3.5 Symbol.prototype[@@toStringTag]
setToStringTag($Symbol, 'Symbol');
// 20.2.1.9 Math[@@toStringTag]
setToStringTag(Math, 'Math', true);
// 24.3.3 JSON[@@toStringTag]
setToStringTag(global.JSON, 'JSON', true);


/***/ }),
/* 39 */
/***/ (function(module, exports, __webpack_require__) {

var global = __webpack_require__(1);
var core = __webpack_require__(12);
var ctx = __webpack_require__(40);
var hide = __webpack_require__(13);
var PROTOTYPE = 'prototype';

var $export = function (type, name, source) {
  var IS_FORCED = type & $export.F;
  var IS_GLOBAL = type & $export.G;
  var IS_STATIC = type & $export.S;
  var IS_PROTO = type & $export.P;
  var IS_BIND = type & $export.B;
  var IS_WRAP = type & $export.W;
  var exports = IS_GLOBAL ? core : core[name] || (core[name] = {});
  var expProto = exports[PROTOTYPE];
  var target = IS_GLOBAL ? global : IS_STATIC ? global[name] : (global[name] || {})[PROTOTYPE];
  var key, own, out;
  if (IS_GLOBAL) source = name;
  for (key in source) {
    // contains in native
    own = !IS_FORCED && target && target[key] !== undefined;
    if (own && key in exports) continue;
    // export native or passed
    out = own ? target[key] : source[key];
    // prevent global pollution for namespaces
    exports[key] = IS_GLOBAL && typeof target[key] != 'function' ? source[key]
    // bind timers to global for call from export context
    : IS_BIND && own ? ctx(out, global)
    // wrap global constructors for prevent change them in library
    : IS_WRAP && target[key] == out ? (function (C) {
      var F = function (a, b, c) {
        if (this instanceof C) {
          switch (arguments.length) {
            case 0: return new C();
            case 1: return new C(a);
            case 2: return new C(a, b);
          } return new C(a, b, c);
        } return C.apply(this, arguments);
      };
      F[PROTOTYPE] = C[PROTOTYPE];
      return F;
    // make static versions for prototype methods
    })(out) : IS_PROTO && typeof out == 'function' ? ctx(Function.call, out) : out;
    // export proto methods to core.%CONSTRUCTOR%.methods.%NAME%
    if (IS_PROTO) {
      (exports.virtual || (exports.virtual = {}))[key] = out;
      // export proto methods to core.%CONSTRUCTOR%.prototype.%NAME%
      if (type & $export.R && expProto && !expProto[key]) hide(expProto, key, out);
    }
  }
};
// type bitmap
$export.F = 1;   // forced
$export.G = 2;   // global
$export.S = 4;   // static
$export.P = 8;   // proto
$export.B = 16;  // bind
$export.W = 32;  // wrap
$export.U = 64;  // safe
$export.R = 128; // real proto method for `library`
module.exports = $export;


/***/ }),
/* 40 */
/***/ (function(module, exports, __webpack_require__) {

// optional / simple context binding
var aFunction = __webpack_require__(41);
module.exports = function (fn, that, length) {
  aFunction(fn);
  if (that === undefined) return fn;
  switch (length) {
    case 1: return function (a) {
      return fn.call(that, a);
    };
    case 2: return function (a, b) {
      return fn.call(that, a, b);
    };
    case 3: return function (a, b, c) {
      return fn.call(that, a, b, c);
    };
  }
  return function (/* ...args */) {
    return fn.apply(that, arguments);
  };
};


/***/ }),
/* 41 */
/***/ (function(module, exports) {

module.exports = function (it) {
  if (typeof it != 'function') throw TypeError(it + ' is not a function!');
  return it;
};


/***/ }),
/* 42 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(13);


/***/ }),
/* 43 */
/***/ (function(module, exports, __webpack_require__) {

var META = __webpack_require__(11)('meta');
var isObject = __webpack_require__(10);
var has = __webpack_require__(6);
var setDesc = __webpack_require__(5).f;
var id = 0;
var isExtensible = Object.isExtensible || function () {
  return true;
};
var FREEZE = !__webpack_require__(8)(function () {
  return isExtensible(Object.preventExtensions({}));
});
var setMeta = function (it) {
  setDesc(it, META, { value: {
    i: 'O' + ++id, // object ID
    w: {}          // weak collections IDs
  } });
};
var fastKey = function (it, create) {
  // return primitive with prefix
  if (!isObject(it)) return typeof it == 'symbol' ? it : (typeof it == 'string' ? 'S' : 'P') + it;
  if (!has(it, META)) {
    // can't set metadata to uncaught frozen object
    if (!isExtensible(it)) return 'F';
    // not necessary to add metadata
    if (!create) return 'E';
    // add missing metadata
    setMeta(it);
  // return object ID
  } return it[META].i;
};
var getWeak = function (it, create) {
  if (!has(it, META)) {
    // can't set metadata to uncaught frozen object
    if (!isExtensible(it)) return true;
    // not necessary to add metadata
    if (!create) return false;
    // add missing metadata
    setMeta(it);
  // return hash weak collections IDs
  } return it[META].w;
};
// add metadata on freeze-family methods calling
var onFreeze = function (it) {
  if (FREEZE && meta.NEED && isExtensible(it) && !has(it, META)) setMeta(it);
  return it;
};
var meta = module.exports = {
  KEY: META,
  NEED: false,
  fastKey: fastKey,
  getWeak: getWeak,
  onFreeze: onFreeze
};


/***/ }),
/* 44 */
/***/ (function(module, exports, __webpack_require__) {

var def = __webpack_require__(5).f;
var has = __webpack_require__(6);
var TAG = __webpack_require__(17)('toStringTag');

module.exports = function (it, tag, stat) {
  if (it && !has(it = stat ? it : it.prototype, TAG)) def(it, TAG, { configurable: true, value: tag });
};


/***/ }),
/* 45 */
/***/ (function(module, exports, __webpack_require__) {

var global = __webpack_require__(1);
var core = __webpack_require__(12);
var LIBRARY = __webpack_require__(24);
var wksExt = __webpack_require__(23);
var defineProperty = __webpack_require__(5).f;
module.exports = function (name) {
  var $Symbol = core.Symbol || (core.Symbol = LIBRARY ? {} : global.Symbol || {});
  if (name.charAt(0) != '_' && !(name in $Symbol)) defineProperty($Symbol, name, { value: wksExt.f(name) });
};


/***/ }),
/* 46 */
/***/ (function(module, exports, __webpack_require__) {

// all enumerable object keys, includes symbols
var getKeys = __webpack_require__(18);
var gOPS = __webpack_require__(29);
var pIE = __webpack_require__(20);
module.exports = function (it) {
  var result = getKeys(it);
  var getSymbols = gOPS.f;
  if (getSymbols) {
    var symbols = getSymbols(it);
    var isEnum = pIE.f;
    var i = 0;
    var key;
    while (symbols.length > i) if (isEnum.call(it, key = symbols[i++])) result.push(key);
  } return result;
};


/***/ }),
/* 47 */
/***/ (function(module, exports, __webpack_require__) {

// fallback for non-array-like ES3 and non-enumerable old V8 strings
var cof = __webpack_require__(26);
// eslint-disable-next-line no-prototype-builtins
module.exports = Object('z').propertyIsEnumerable(0) ? Object : function (it) {
  return cof(it) == 'String' ? it.split('') : Object(it);
};


/***/ }),
/* 48 */
/***/ (function(module, exports) {

// 7.2.1 RequireObjectCoercible(argument)
module.exports = function (it) {
  if (it == undefined) throw TypeError("Can't call method on  " + it);
  return it;
};


/***/ }),
/* 49 */
/***/ (function(module, exports, __webpack_require__) {

// false -> Array#indexOf
// true  -> Array#includes
var toIObject = __webpack_require__(7);
var toLength = __webpack_require__(50);
var toAbsoluteIndex = __webpack_require__(51);
module.exports = function (IS_INCLUDES) {
  return function ($this, el, fromIndex) {
    var O = toIObject($this);
    var length = toLength(O.length);
    var index = toAbsoluteIndex(fromIndex, length);
    var value;
    // Array#includes uses SameValueZero equality algorithm
    // eslint-disable-next-line no-self-compare
    if (IS_INCLUDES && el != el) while (length > index) {
      value = O[index++];
      // eslint-disable-next-line no-self-compare
      if (value != value) return true;
    // Array#indexOf ignores holes, Array#includes - not
    } else for (;length > index; index++) if (IS_INCLUDES || index in O) {
      if (O[index] === el) return IS_INCLUDES || index || 0;
    } return !IS_INCLUDES && -1;
  };
};


/***/ }),
/* 50 */
/***/ (function(module, exports, __webpack_require__) {

// 7.1.15 ToLength
var toInteger = __webpack_require__(27);
var min = Math.min;
module.exports = function (it) {
  return it > 0 ? min(toInteger(it), 0x1fffffffffffff) : 0; // pow(2, 53) - 1 == 9007199254740991
};


/***/ }),
/* 51 */
/***/ (function(module, exports, __webpack_require__) {

var toInteger = __webpack_require__(27);
var max = Math.max;
var min = Math.min;
module.exports = function (index, length) {
  index = toInteger(index);
  return index < 0 ? max(index + length, 0) : min(index, length);
};


/***/ }),
/* 52 */
/***/ (function(module, exports, __webpack_require__) {

// 7.2.2 IsArray(argument)
var cof = __webpack_require__(26);
module.exports = Array.isArray || function isArray(arg) {
  return cof(arg) == 'Array';
};


/***/ }),
/* 53 */
/***/ (function(module, exports, __webpack_require__) {

// 19.1.2.2 / 15.2.3.5 Object.create(O [, Properties])
var anObject = __webpack_require__(9);
var dPs = __webpack_require__(54);
var enumBugKeys = __webpack_require__(19);
var IE_PROTO = __webpack_require__(28)('IE_PROTO');
var Empty = function () { /* empty */ };
var PROTOTYPE = 'prototype';

// Create object with fake `null` prototype: use iframe Object with cleared prototype
var createDict = function () {
  // Thrash, waste and sodomy: IE GC bug
  var iframe = __webpack_require__(22)('iframe');
  var i = enumBugKeys.length;
  var lt = '<';
  var gt = '>';
  var iframeDocument;
  iframe.style.display = 'none';
  __webpack_require__(55).appendChild(iframe);
  iframe.src = 'javascript:'; // eslint-disable-line no-script-url
  // createDict = iframe.contentWindow.Object;
  // html.removeChild(iframe);
  iframeDocument = iframe.contentWindow.document;
  iframeDocument.open();
  iframeDocument.write(lt + 'script' + gt + 'document.F=Object' + lt + '/script' + gt);
  iframeDocument.close();
  createDict = iframeDocument.F;
  while (i--) delete createDict[PROTOTYPE][enumBugKeys[i]];
  return createDict();
};

module.exports = Object.create || function create(O, Properties) {
  var result;
  if (O !== null) {
    Empty[PROTOTYPE] = anObject(O);
    result = new Empty();
    Empty[PROTOTYPE] = null;
    // add "__proto__" for Object.getPrototypeOf polyfill
    result[IE_PROTO] = O;
  } else result = createDict();
  return Properties === undefined ? result : dPs(result, Properties);
};


/***/ }),
/* 54 */
/***/ (function(module, exports, __webpack_require__) {

var dP = __webpack_require__(5);
var anObject = __webpack_require__(9);
var getKeys = __webpack_require__(18);

module.exports = __webpack_require__(4) ? Object.defineProperties : function defineProperties(O, Properties) {
  anObject(O);
  var keys = getKeys(Properties);
  var length = keys.length;
  var i = 0;
  var P;
  while (length > i) dP.f(O, P = keys[i++], Properties[P]);
  return O;
};


/***/ }),
/* 55 */
/***/ (function(module, exports, __webpack_require__) {

var document = __webpack_require__(1).document;
module.exports = document && document.documentElement;


/***/ }),
/* 56 */
/***/ (function(module, exports, __webpack_require__) {

// fallback for IE11 buggy Object.getOwnPropertyNames with iframe and window
var toIObject = __webpack_require__(7);
var gOPN = __webpack_require__(30).f;
var toString = {}.toString;

var windowNames = typeof window == 'object' && window && Object.getOwnPropertyNames
  ? Object.getOwnPropertyNames(window) : [];

var getWindowNames = function (it) {
  try {
    return gOPN(it);
  } catch (e) {
    return windowNames.slice();
  }
};

module.exports.f = function getOwnPropertyNames(it) {
  return windowNames && toString.call(it) == '[object Window]' ? getWindowNames(it) : gOPN(toIObject(it));
};


/***/ }),
/* 57 */
/***/ (function(module, exports, __webpack_require__) {

var pIE = __webpack_require__(20);
var createDesc = __webpack_require__(15);
var toIObject = __webpack_require__(7);
var toPrimitive = __webpack_require__(14);
var has = __webpack_require__(6);
var IE8_DOM_DEFINE = __webpack_require__(21);
var gOPD = Object.getOwnPropertyDescriptor;

exports.f = __webpack_require__(4) ? gOPD : function getOwnPropertyDescriptor(O, P) {
  O = toIObject(O);
  P = toPrimitive(P, true);
  if (IE8_DOM_DEFINE) try {
    return gOPD(O, P);
  } catch (e) { /* empty */ }
  if (has(O, P)) return createDesc(!pIE.f.call(O, P), O[P]);
};


/***/ }),
/* 58 */
/***/ (function(module, exports) {

module.exports = "<div class=\"bx-modal-panel bx-modal-sms\">\n  <div class=\"bx-modal-overlay\"></div>\n  <div class=\"bx-modal\">\n    <div class=\"bx-modal-body\">\n      <div class=\"bx-modal-inner\">\n        <div class=\"bx-modal-title\">短信验证码</div>\n        <div class=\"bx-modal-content\">\n          <div class=\"bx-sms-panel\">\n            <div class=\"bx-sms-form\">\n              <input class=\"bx-sms-input\" type=\"text\" placeholder=\"请输入短信验证码\"/>\n            </div>\n            <a class=\"bx-sms-btn js-btn-sms\">获取验证码</a>\n            <a class=\"bx-sms-btn bx-sms-btn--disable\">重新获取(<span class=\"bx-sms-count\">5</span>s)</a>\n          </div>\n        </div>\n      </div>\n    </div>\n    <div class=\"bx-modal-footer\">\n      <div class=\"bx-modal-buttons\">\n        <a class=\"bx-modal-btn js-btn-cancel\">取消</a>\n        <a class=\"bx-modal-btn bx-modal-link js-btn-submit\">提交</a>\n      </div>\n    </div>\n  </div>\n</div>\n";

/***/ }),
/* 59 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

__webpack_require__(60);

var _loadingWaiting = __webpack_require__(61);

var _loadingWaiting2 = _interopRequireDefault(_loadingWaiting);

var _loadingSuccess = __webpack_require__(62);

var _loadingSuccess2 = _interopRequireDefault(_loadingSuccess);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Loading = {
  show: function show(options) {
    _loadingWaiting2.default.show(options);
  },
  hide: function hide() {
    _loadingWaiting2.default.hide();
  },
  success: function success(el, options) {
    // eslint-disable-next-line
    return new _loadingSuccess2.default(el, options);
  }
};

exports.default = Loading;
module.exports = exports['default'];

/***/ }),
/* 60 */
/***/ (function(module, exports) {

// removed by extract-text-webpack-plugin

/***/ }),
/* 61 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var ua = window.navigator.userAgent;
var vers;
var env = {};
var regexp = {
  // eslint-disable-next-line
  ios: /OS ([\d_\.]+) like Mac OS X/,
  // eslint-disable-next-line
  android: /Android[\s\/]([\d\.]+)/
};
if (ua.match(regexp.ios)) {
  vers = ua.match(regexp.ios);
  env.os = {
    name: 'IOS',
    isIOS: !0,
    version: vers[1].split('_').join('.')
  };
} else if (ua.match(regexp.android)) {
  // eslint-disable-next-line
  vers = ua.match(regexp.android);
  env.os = {
    name: 'Android',
    isAndroid: !0,
    version: vers[1]
  };
} else {
  env.os = { name: 'unknown', version: '0.0.0' };
}

var loading = {
  html: '',
  css3: false,
  svg: false,
  canvas: false,
  normal: false,
  version: env.os.version,
  // 元素缩放比
  scale: 1,
  timer: null,
  _normalHtml: function _normalHtml() {
    this.html += '<div class="loading-circle">';
    this.html += '<div class="loading-half-circle"></div>';
    this.html += '</div>';
  },
  _css3Html: function _css3Html() {
    this.html += '<div class="loading-circle rotation-self">';
    this.html += '<div class="loading-half-circle rotation-clip"></div>';
    this.html += '</div>';
  },
  // css3对android 4.3及以下进行降级处理
  _css3CompatibleHtml: function _css3CompatibleHtml() {
    this.html += '<div class="loading-circle circle-clip-auto">';
    this.html += '<div class="loading-half-circle rotation-self-360"></div>';
    this.html += '</div>';
  },
  _svgHtml: function _svgHtml() {
    this.html += '<svg class="loading-svg" width="80" height="80" xmlns="http://www.w3.org/2000/svg">';
    this.html += '<circle cx="40" cy="40" r="30" stroke="#FFF" fill="none" stroke-width="3" stroke-linecap="round">';
    this.html += '<animate attributeName="stroke-dashoffset" dur="1.6s" repeatCount="indefinite" from="427" to="45"></animate>';
    this.html += '<animate attributeName="stroke-dasharray" dur="1.6s" repeatCount="indefinite" values="121 70;1 190;121 70"></animate>';
    this.html += '</circle>';
    this.html += '</svg>';
  },
  _canvasHtml: function _canvasHtml() {
    this.html += '<canvas id="loading-canvas" class="loading-canvas" width="80" height="80"></canvas>';
  },
  _normalInit: function _normalInit() {
    // 进度条长度阀值
    var threshold = 0;
    // 定时器间隔时间
    var during = 20;
    // 每个during转动角度
    var angle = 8;
    // 进度条转动720度为一个周期,周期分为3个间隔
    // 第一个间隔,进度条长度增加
    // 第二个间隔,进度条长度不变
    // 第三个间隔,进度条长度减少
    var section = 720 / 3 / angle;

    var counter = 0;
    var rotateSelf = 0;
    var rotateHalf = 0;
    this.timer = window.setInterval(function () {
      counter++;
      if (counter <= section) {
        threshold += during;
        rotateHalf = threshold / (during * section) * 180;
      }
      if (counter >= section && counter <= section * 2) {
        rotateHalf = 180;
      }
      if (counter >= section * 2 && counter <= section * 3) {
        threshold -= during;
        rotateHalf = 180 - threshold / (during * section) * 180 + 180;
      }
      if (counter === section * 3) {
        threshold = 0;
        counter = 0;
        rotateHalf = 0;
      }
      rotateSelf = counter / (3 * section) * 540;

      document.getElementsByClassName('loading-circle')[0].style.transform = 'rotate(' + rotateSelf + 'deg)';
      document.getElementsByClassName('loading-circle')[0].style.WebkitTransform = 'rotate(' + rotateSelf + 'deg)';
      document.getElementsByClassName('loading-half-circle')[0].style.transform = 'rotate(' + rotateHalf + 'deg)';
      document.getElementsByClassName('loading-half-circle')[0].style.WebkitTransform = 'rotate(' + rotateHalf + 'deg)';
    }, during);
  },
  _canvasInit: function _canvasInit() {
    // 初始化canvas

    var canvas = document.getElementById('loading-canvas');
    var ctx = canvas.getContext('2d');

    var x = canvas.width / 2;
    var y = canvas.height / 2;

    // 解决IOS retina屏下绘制图像模糊
    var devicePixelRatio = window.devicePixelRatio || 1;
    var backingStoreRatio = ctx.webkitBackingStorePixelRatio || ctx.mozBackingStorePixelRatio || ctx.msBackingStorePixelRatio || ctx.oBackingStorePixelRatio || ctx.backingStorePixelRatio || 1;
    var ratio = devicePixelRatio / backingStoreRatio;
    if (devicePixelRatio !== backingStoreRatio) {
      var oldWidth = canvas.width;
      var oldHeight = canvas.height;
      canvas.width = oldWidth * ratio;
      canvas.height = oldHeight * ratio;
      canvas.style.width = oldWidth + 'px';
      canvas.style.height = oldHeight + 'px';
      ctx.scale(ratio, ratio);
    }
    // 解决IOS retina屏下绘制图像模糊

    // 进度条长度阀值
    var threshold = 0;
    // 定时器间隔时间
    var during = 15;
    // 每个during转动角度
    var angle = 6;
    // 进度条转动720度为一个周期,周期分为3个间隔
    // 第一个间隔,进度条长度增加
    // 第二个间隔,进度条长度不变
    // 第三个间隔,进度条长度减少
    var section = 720 / 3 / angle;
    var counter = 0;

    this.timer = window.setInterval(function () {
      counter++;
      // 第一个间隔,进度条长度增加
      if (counter <= section) {
        threshold += during;
      }
      // 第三个间隔,进度条长度减少
      if (counter >= section * 2 && counter <= section * 3) {
        threshold -= during;
      }
      // 一个周期结束,重置
      if (counter === section * 3) {
        threshold = 0;
        counter = 0;
      }
      rotate();
      drawArc();
    }, during);
    // 画布旋转angle角度
    function rotate() {
      ctx.translate(x, y); // 将绘图原点移到画布中点
      ctx.rotate(Math.PI / 180 * angle); // 旋转角度
      ctx.translate(-x, -y); // 将画布原点移动
    }

    // 在画布上画进度条
    function drawArc() {
      ctx.clearRect(0, 0, canvas.width, canvas.height);
      ctx.lineWidth = 3;
      ctx.strokeStyle = '#FFF';
      ctx.beginPath();
      ctx.arc(40, 40, 30, 1.5 * Math.PI, (threshold / (during * section) + 1.5) * Math.PI);
      ctx.stroke();
      ctx.closePath();
    }
  },
  // 在版本号ver及ver以下,如ver=4.4.4,则表示包含4.4.4及以下
  underVersion: function underVersion(ver) {
    if (this.compareVersion(this.version, ver) === '=') {
      return true;
    }
    if (this.compareVersion(this.version, ver) === '<') {
      return true;
    }
    return false;
  },
  // 获取viewport content中的参数
  getViewPortParam: function getViewPortParam(name) {
    var viewport = document.querySelector('meta[name=viewport]');
    if (!viewport) {
      return null;
    }
    var content = viewport.getAttribute('content');
    if (!content) {
      return null;
    }
    // eslint-disable-next-line
    name = name.replace(/[\[]/, '\\[').replace(/[\]]/, '\\]');
    var regex = new RegExp('(^|,)' + name + '=([^,]*)(,|$)', 'i');
    var results = regex.exec(content);

    return results === null ? null : decodeURIComponent(results[2].replace(/\+/g, ' '));
  },
  // 根据viewport设置放大倍数,默认为1
  setScale: function setScale() {
    var initialScale = this.getViewPortParam('initial-scale') || 0;
    var maximumScale = this.getViewPortParam('maximum-scale') || 0;
    var minimumScale = this.getViewPortParam('minimum-scale') || 0;
    var scale = initialScale;
    if (maximumScale !== 0 && maximumScale <= initialScale) {
      scale = maximumScale;
    }
    if (minimumScale !== 0 && minimumScale >= initialScale) {
      scale = minimumScale;
    }
    this.scale = 1.0 / scale;
  },
  // 比较两个版本号
  compareVersion: function compareVersion(curr, target) {
    if (curr === target) {
      return '=';
    }
    var currArr = curr.split('.');
    var targetArr = target.split('.');
    var len = currArr.length >= targetArr.length ? currArr.length : targetArr.length;

    for (var i = 0; i < len; i++) {
      if (!currArr[i]) {
        currArr[i] = 0;
      }
      if (!targetArr[i]) {
        targetArr[i] = 0;
      }

      if (currArr[i] > targetArr[i]) {
        return '>';
      } else if (currArr[i] < targetArr[i]) {
        return '<';
      }
    }

    return '=';
  },
  // 显示loading,共有4中实现方式 1、css3   2、js timer 3、svg  4、canvas
  show: function show(options) {
    this.html = '';
    options = options || {};
    this.css3 = options.css3 || false;
    this.svg = options.svg || false;
    this.canvas = options.canvas || false;
    this.normal = options.normal || false;

    this.setScale();

    // 如果dom已存在,则不再重复添加
    var logoLoading = document.getElementsByClassName('logo-loading');
    if (logoLoading.length > 0) {
      console.log('dom已存在');
      return;
    }

    // 创建loading dom
    var div = document.createElement('div');
    div.className = 'logo-loading';
    if (env.os.isIOS) {
      // scale放大缩小会造成失真
      // div.style.transform = 'scale(' + this.scale + ')';
      // div.style.WebkitTransform = 'scale(' + this.scale + ')';
      div.style.zoom = this.scale;
    }
    if (this.css3) {
      this._css3Html();
    } else if (this.normal) {
      this._normalHtml();
    } else if (this.svg) {
      this._svgHtml();
    } else if (this.canvas) {
      this._canvasHtml();
    } else {
      if (env.os.isIOS) {
        this._canvasHtml();
      } else if (env.os.isAndroid && this.underVersion('4.3.0')) {
        this._css3CompatibleHtml();
      } else {
        this._css3Html();
      }
    }
    this.html += '<div class="logo-icon">';
    this.html += '<p></p> <p></p> <p></p> <p></p> <p></p> <p></p> <p></p>';
    this.html += '</div>';
    div.innerHTML = this.html;
    document.body.appendChild(div);
    var canvas = document.getElementById('loading-canvas');
    if (canvas) {
      this._canvasInit();
    }
    if (this.normal) {
      this._normalInit();
    }
  },
  // 隐藏loading
  hide: function hide() {
    var logoLoading = document.getElementsByClassName('logo-loading');
    if (logoLoading.length > 0) {
      var _element = logoLoading[0];
      _element.parentNode.removeChild(_element);
      if (this.timer) {
        clearInterval(this.timer);
        this.timer = null;
      }
    }
  }
};
exports.default = loading;
module.exports = exports['default'];

/***/ }),
/* 62 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _utils = __webpack_require__(0);

var _utils2 = _interopRequireDefault(_utils);

var _eventBus = __webpack_require__(2);

var _eventBus2 = _interopRequireDefault(_eventBus);

var _extends = __webpack_require__(3);

var _extends2 = _interopRequireDefault(_extends);

var _requestAnimationFrame = __webpack_require__(63);

var _requestAnimationFrame2 = _interopRequireDefault(_requestAnimationFrame);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ACTIONS = {
  START: 'START',
  SPIN_ROTATE: 'SPIN_ROTATE',
  SPIN_ZOOMOUT: 'SPIN_ZOOMOUT',
  ARC_ZOOMIN: 'ARC_ZOOMIN',
  TICK_DRAW: 'TICK_DRAW',
  END: 'END'
};

var Point = function Point(x, y) {
  this.x = x;
  this.y = y;
};

var Loading = function Loading(el, options) {
  this.wrapper = typeof el === 'string' ? document.querySelector(el) : el;
  var defaults = {
    background: '#FFF',
    spin: {
      lines: 8,
      speed: 1000,
      zoomSpeed: 1500
    },
    arc: {
      zoomSpeed: 1000
    },
    tick: {
      AToB: 4,
      BToC: 8
    },
    onSuccess: _utils2.default.noop
  };
  this.options = defaults;
  (0, _extends2.default)(this.options, options);
  this.unique = this.options.unique || _utils2.default.getUnique();
  this.ACTIONS = ACTIONS;
  this.action = ACTIONS.START;
  this.requestId = null;
  this._init();
};

Loading.prototype = {
  _init: function _init() {
    var self = this;
    self._createCanvas();
    self.observer = _eventBus2.default.create(self.unique);
    self._addEvent();
  },
  _createCanvas: function _createCanvas() {
    var self = this;
    var _wrapper = self.wrapper;
    var _canvas = document.createElement('canvas');
    var _ctx = _canvas.getContext('2d');
    _wrapper.appendChild(_canvas);
    var _width = _wrapper.clientWidth;
    var _height = _wrapper.clientHeight;
    self._setCanvasWH(_canvas, _ctx, _width, _height);
    _ctx.fillStyle = self.options.background;
    _ctx.fillRect(0, 0, _canvas.width, _canvas.height);
    self._canvas = _canvas;
    self._ctx = _ctx;
    self.width = _width;
    self.height = _height;
    self._setConfig();
    self.path = self._createTickPath(self.radius);
  },
  // 设置canvas的宽高
  _setCanvasWH: function _setCanvasWH(canvas, ctx, width, height) {
    var self = this;
    var ratio = self._calculatePixelRatio(ctx);
    if (ratio !== 1) {
      canvas.width = width * ratio;
      canvas.height = height * ratio;
      canvas.style.width = width + 'px';
      canvas.style.height = height + 'px';
      ctx.scale(ratio, ratio);
    } else {
      canvas.width = width;
      canvas.height = height;
    }
  },
  _setConfig: function _setConfig() {
    var self = this;
    self.action = ACTIONS.START;
    self.currentSpin = 0;
    self.currentSpinZoom = 1;
    self.currentArcZoom = 0;
    self.currentPath = 1;
    self.currentTickPoint = 10;
    self.options.spin.width || (self.options.spin.width = self.width / 15);
    self.options.tick.width || (self.options.tick.width = self.width / 15);
    var radius = self.width / 2.5;
    self.radius = radius;
    // 打钩的三个关键点
    self.A = new Point(-1 * radius / 2, radius / 20);
    self.B = new Point(-1 * radius / 20, radius / 2);
    self.C = new Point(radius / 2, -1 * radius / 3);
  },
  // 解决retina屏下绘制图像模糊
  _calculatePixelRatio: function _calculatePixelRatio(ctx) {
    var devicePixelRatio = window.devicePixelRatio || 1;
    var backingStoreRatio = ctx.webkitBackingStorePixelRatio || ctx.mozBackingStorePixelRatio || ctx.msBackingStorePixelRatio || ctx.oBackingStorePixelRatio || ctx.backingStorePixelRatio || 1;
    return devicePixelRatio / backingStoreRatio;
  },
  _addEvent: function _addEvent() {
    var self = this;
    window['addEventListener']('resize', this, false);
    for (var item in self.options) {
      if (item.indexOf('on') === 0) {
        if (self.options[item] instanceof Function) {
          (function (item, _self) {
            _self.observer.on(item, function () {
              _self.options[item].apply(_self, Array.prototype.slice.call(arguments));
            });
          })(item, self);
        }
      }
    }
  },
  _onResize: function _onResize(e) {
    console.log('resize');
  },
  _createTickPath: function _createTickPath(radius) {
    var self = this;
    var path = [];
    var A = self.A;
    var B = self.B;
    var C = self.C;
    var AToB = self.options.tick.AToB;
    var ABK = (B.y - A.y) / (B.x - A.x);
    var ABXLength = Math.abs(B.x - A.x);
    var BToC = self.options.tick.BToC;
    var BCK = (C.y - B.y) / (C.x - B.x);
    var BCXLength = Math.abs(C.x - B.x);
    path.push(A);
    var i = 0;
    var x = 0;
    var y = 0;
    for (i = 0; i < AToB; i++) {
      x = A.x + (i + 1) * ABXLength / (AToB + 1);
      y = A.y + ABK * (i + 1) * ABXLength / (AToB + 1);
      path.push(new Point(x, y));
    }
    path.push(B);
    for (i = 0; i < BToC; i++) {
      x = B.x + (i + 1) * BCXLength / (BToC + 1);
      y = B.y + BCK * (i + 1) * BCXLength / (BToC + 1);
      path.push(new Point(x, y));
    }
    path.push(C);
    return path;
  },
  _drawLine: function _drawLine(start, end) {
    var self = this;
    var _ctx = self._ctx;
    _ctx.beginPath();
    _ctx.moveTo(start.x, start.y);
    _ctx.lineTo(end.x, end.y);
    _ctx.lineCap = 'round';
    _ctx.lineJoin = 'round';
    _ctx.lineWidth = self.options.tick.width;
    _ctx.strokeStyle = '#FFF';
    _ctx.closePath();
    _ctx.stroke();
  },
  _drawSpin: function _drawSpin() {
    var self = this;
    var _ctx = self._ctx;
    var width = self.width;
    var height = self.height;
    var rotation = 360 / self.options.spin.lines;
    _ctx.save();
    _ctx.clearRect(0, 0, width, height);
    _ctx.translate(width / 2, height / 2);
    var opacity = 1;
    var i = 0;
    for (i = 0; i < self.currentSpin; i++) {
      _ctx.beginPath();
      _ctx.rotate(-1 * rotation * Math.PI / 180);
      _ctx.moveTo(0, -1 * width / 6);
      _ctx.lineTo(0, -1 * width / 3);
      _ctx.lineCap = 'round';
      _ctx.lineWidth = self.options.spin.width;
      if (self.currentSpin - i < 1) {
        opacity = self.currentSpin - i;
      }
      _ctx.strokeStyle = 'rgba(80, 140, 238,' + opacity + ')';
      _ctx.stroke();
    }
    _ctx.restore();
    if (self.currentSpin < self.options.spin.lines) {
      self.currentSpin = parseFloat(self.currentSpin) + 100 / self.options.spin.speed;
    } else {
      self.currentSpin = 0;
    }
    // 防止小数精度问题产生的bug
    self.currentSpin = self.currentSpin.toFixed(3);
  },
  _drawSpinZoom: function _drawSpinZoom(callback) {
    var self = this;
    var _ctx = self._ctx;
    var width = self.width;
    var height = self.height;
    _ctx.save();
    _ctx.clearRect(0, 0, width, height);
    _ctx.translate(width / 2, height / 2);
    _ctx.scale(self.currentSpinZoom, self.currentSpinZoom);
    if (self.currentSpinZoom > 0) {
      self.currentSpinZoom -= 100 / self.options.spin.zoomSpeed;
    } else {
      self.currentSpinZoom = 0;
      callback && callback();
    }
    for (var i = 0; i < self.options.spin.lines; i++) {
      _ctx.beginPath();
      _ctx.rotate(Math.PI * 2 / self.options.spin.lines);
      _ctx.moveTo(width / 6, 0);
      _ctx.lineTo(width / 3, 0);
      _ctx.lineCap = 'round';
      _ctx.lineWidth = self.options.spin.width;
      _ctx.strokeStyle = 'rgba(80, 140, 238, 1)';
      _ctx.stroke();
    }
    _ctx.restore();
  },
  _drawArc: function _drawArc(callback) {
    var self = this;
    var _ctx = self._ctx;
    var width = self.width;
    var height = self.height;
    _ctx.save();
    _ctx.clearRect(0, 0, width, height);
    _ctx.translate(width / 2, height / 2);
    _ctx.scale(self.currentArcZoom, self.currentArcZoom);
    if (self.currentArcZoom < 1) {
      self.currentArcZoom += 100 / self.options.arc.zoomSpeed;
    } else {
      self.currentArcZoom = 1;
    }
    _ctx.arc(0, 0, width / 2.5, 0, 2 * Math.PI, false);
    _ctx.fillStyle = '#508cee';
    _ctx.fill();
    _ctx.restore();
    callback && callback();
  },
  _drawPoint: function _drawPoint(callback) {
    var self = this;
    var _ctx = self._ctx;
    var width = self.width;
    var height = self.height;
    _ctx.save();
    _ctx.translate(width / 2, height / 2);
    var A = new Point(self.A.x, self.A.y - self.currentTickPoint);
    var B = new Point(A.x + 1, A.y + 1);
    self._drawLine(A, B);
    _ctx.restore();
    if (self.currentTickPoint > 0) {
      self.currentTickPoint -= 1.5;
    } else {
      callback && callback();
    }
  },
  _drawTick: function _drawTick(callback) {
    var self = this;
    var _ctx = self._ctx;
    var width = self.width;
    var height = self.height;
    _ctx.save();
    _ctx.translate(width / 2, height / 2);
    var path = self.path;
    if (self.currentPath < path.length) {
      for (var i = 0; i < self.currentPath; i++) {
        self._drawLine(path[i], path[i + 1]);
      }
      self.currentPath++;
    }
    _ctx.restore();
    if (self.currentPath >= path.length) {
      callback && callback();
    }
  },
  _starAnimation: function _starAnimation() {
    var self = this;
    switch (self.action) {
      case ACTIONS.START:
        self.setAction(ACTIONS.SPIN_ROTATE);
        break;
      case ACTIONS.SPIN_ROTATE:
        self._drawSpin();
        break;
      case ACTIONS.SPIN_ZOOMOUT:
        self._drawSpinZoom(function () {
          self.setAction(ACTIONS.ARC_ZOOMIN);
        });
        break;
      case ACTIONS.ARC_ZOOMIN:
        self._drawArc(function () {
          if (self.currentArcZoom > 0.5) {
            self._drawPoint(function () {
              self.setAction(ACTIONS.TICK_DRAW);
            });
          }
        });
        break;
      case ACTIONS.TICK_DRAW:
        self._drawTick(function () {
          self.setAction(ACTIONS.END);
        });
        break;
      case ACTIONS.END:
        self.observer.emit('onSuccess');
        self._stopAnimation();
        break;
    }
    self.requestId && _requestAnimationFrame2.default.requestAnimationFrame(function () {
      self._starAnimation();
    });
  },
  _stopAnimation: function _stopAnimation() {
    var self = this;
    _requestAnimationFrame2.default.cancelAnimationFrame(self.requestId);
    self.requestId = null;
  },
  handleEvent: function handleEvent(e) {
    switch (e.type) {
      case 'resize':
        this._onResize(e);
        break;
    }
  },
  setAction: function setAction(actName) {
    var self = this;
    self.action = actName;
  },
  clear: function clear() {
    var self = this;
    var _canvas = self._canvas;
    var _ctx = self._ctx;
    _ctx.fillStyle = self.options.backgroundColor;
    _ctx.clearRect(0, 0, _canvas.width, _canvas.height);
    _ctx.fillRect(0, 0, _canvas.width, _canvas.height);
  },
  start: function start() {
    var self = this;
    self._setConfig();
    self.requestId = _requestAnimationFrame2.default.requestAnimationFrame(function () {
      self._starAnimation();
    });
  },
  stop: function stop() {
    var self = this;
    self._stopAnimation();
  },
  success: function success() {
    var self = this;
    self.setAction(ACTIONS.SPIN_ZOOMOUT);
  }
};

exports.default = Loading;
module.exports = exports['default'];

/***/ }),
/* 63 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
/* eslint-disable */
if (!Date.now) {
  Date.now = function () {
    return new Date().getTime();
  };
}
var vendors = ['ms', 'moz', 'webkit', 'o'];
for (var i = 0; i < vendors.length && !window.requestAnimationFrame; ++i) {
  var vendor = vendors[i];
  window.requestAnimationFrame = window[vendor + 'RequestAnimationFrame'];
  window.cancelAnimationFrame = window[vendor + 'CancelAnimationFrame'] || window[vendor + 'CancelRequestAnimationFrame'];
}
// iOS6 is buggy
if (/iP(ad|hone|od).*OS 6/.test(window.navigator.userAgent) || !window.requestAnimationFrame || !window.cancelAnimationFrame) {
  var lastTime = 0;
  window.requestAnimationFrame = function (callback) {
    var now = Date.now();
    var nextTime = Math.max(lastTime + 16, now);
    return setTimeout(function () {
      callback(lastTime = nextTime);
    }, nextTime - now);
  };
  window.cancelAnimationFrame = clearTimeout;
}

exports.default = {
  requestAnimationFrame: function requestAnimationFrame(callback) {
    return window.requestAnimationFrame(callback);
  },
  cancelAnimationFrame: function cancelAnimationFrame(requestID) {
    return window.cancelAnimationFrame(requestID);
  }
};
module.exports = exports['default'];

/***/ }),
/* 64 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

__webpack_require__(65);

var _utils = __webpack_require__(0);

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var eStart = _utils2.default.support.touch ? 'touchstart' : 'mousedown';
var eMove = _utils2.default.support.touch ? 'touchmove' : 'mousemove';
var eEnd = _utils2.default.support.touch ? 'touchend' : 'mouseup';

// 记录页面上所有的音频播放器
window.audioArr = [];
// 暂停所有正在播放的音频
window.pausePlayingAudio = function () {
  for (var i = 0; i < window.audioArr.length; i++) {
    if (_utils2.default.hasClass(window.audioArr[i].player, 'audio-playing')) {
      window.audioArr[i].audio.pause();
      _utils2.default.removeClass(window.audioArr[i].player, 'audio-playing');
    }
  }
};

var audioPlayer = function audioPlayer(element, options) {
  this.element = typeof element === 'string' ? document.querySelector(element) : element;
  this.settings = {
    debug: false
  };
  for (var i in options) {
    this.settings[i] = options[i];
  }
  this.init();
};

audioPlayer.prototype = {
  init: function init() {
    var self = this;

    // 如果不是audio标签,则不再往下执行
    if (this.element.tagName.toLowerCase() !== 'audio') {
      return false;
    }

    if (self.settings.debug) {
      _utils2.default._createDebug();
    }

    self.initAudio();
    self.audio = this.element;
    self.createBufferedTimer();
    self.player = self.createPlayer();

    self.timeCurrent.innerText = self.secondsToTime(0);
    self.timeTotal.innerText = self.secondsToTime(0);
    self.element.parentNode.appendChild(self.player);
    self.element.parentNode.removeChild(self.element);
    self.eventAttach();

    window.audioArr.push({
      audio: self.audio,
      player: self.player
    });
  },
  // 初始化音频参数
  initAudio: function initAudio() {
    var self = this;
    var $this = self.element;
    self.audioFile = $this.getAttribute('src');
    // 暂时未有使用,待完善
    // self.isAutoPlay = $this.getAttribute('autoplay');
    // self.isAutoPlay = self.isAutoPlay === '' || self.isAutoPlay === 'autoplay' ? true : false;
    // self.isLoop = $this.getAttribute('loop');
    // self.isLoop = self.isLoop === '' || self.isLoop === 'loop' ? true : false;
    // 暂时未有使用,待完善
    self.isSupport = false;
    if (typeof self.audioFile === 'undefined') {
      $this.getElementsByTagName('source').each(function () {
        self.audioFile = this.getAttribute('src');
      });
    }
  },
  // 创建自定义样式播放器
  createPlayer: function createPlayer() {
    var self = this;
    var html = '';
    html += '<div class="audio-switch">';
    html += '<i class="icon-audio-switch"></i>';
    html += '</div>';
    html += '<div class="audio-detail">';
    if (self.settings.title) {
      html += '<h3 class="audio-detail-title">' + self.settings.title + '</h3>';
    }
    if (self.settings.tips) {
      html += '<p class="audio-detail-tips">' + self.settings.tips + '</p>';
    }
    html += '<div class="audio-progress-wrap">';
    html += '<div class="audio-progress">';
    html += '<div class="audio-progress-buffer"></div>';
    html += '<div class="audio-progress-playing"></div>';
    html += '</div>';
    html += '<div class="audio-progress-handler"><div class="audio-handler-circle"></div></div>';
    html += '</div>';
    html += '<div class="audio-length">';
    html += '<p class="audio-length-current">00:00</p>';
    html += '<p class="audio-length-total">00:00</p>';
    html += '</div>';
    html += '</div>';

    var player = document.createElement('div');
    player.className = 'audio-wrap';
    player.innerHTML = html;

    self.theBar = player.querySelector('.audio-progress-wrap');
    self.barPlaying = player.querySelector('.audio-progress-playing');
    self.barBuffer = player.querySelector('.audio-progress-buffer');
    self.barHandler = player.querySelector('.audio-progress-handler');
    self.timeCurrent = player.querySelector('.audio-length-current');
    self.timeTotal = player.querySelector('.audio-length-total');

    if (self.settings.title && self.settings.tips) {
      // 不做处理
    } else if (!self.settings.title && !self.settings.tips) {
      player.querySelector('.audio-detail').style.marginTop = '22px';
    } else if (self.settings.title && !self.settings.tips) {
      player.querySelector('.audio-detail').style.marginTop = '-7px';
    } else if (!self.settings.title && self.settings.tips) {
      player.querySelector('.audio-detail').style.marginTop = '6px';
    }

    return player;
  },
  // 创建缓冲进度条定时器
  createBufferedTimer: function createBufferedTimer() {
    // readyState状态值
    // 0 = HAVE_NOTHING - 没有关于音频/视频是否就绪的信息
    // 1 = HAVE_METADATA - 关于音频/视频就绪的元数据
    // 2 = HAVE_CURRENT_DATA - 关于当前播放位置的数据是可用的，但没有足够的数据来播放下一帧/毫秒
    // 3 = HAVE_FUTURE_DATA - 当前及至少下一帧的数据是可用的
    // 4 = HAVE_ENOUGH_DATA - 可用数据足以开始播放

    var self = this;
    if (!self.bufferedTimer) {
      self.bufferedTimer = setInterval(function () {
        if (self.audio.buffered && self.audio.duration && self.audio.readyState >= 3) {
          self.barBuffer.style.width = self.audio.buffered.end(0) / self.audio.duration * 100 + '%';
          if (self.audio.buffered.end(0) >= self.audio.duration) {
            clearInterval(self.bufferedTimer);
            self.bufferedTimer = null;
          }
        }
      }, 200);
    }
  },
  // 事件绑定
  eventAttach: function eventAttach() {
    var self = this;

    // Chrome事件顺序: loadedmetadata(duration开始有值)、loadeddata
    // Chrome点击播放: play、playing、timeupdate
    // chrome点击暂停: pause
    // Chrome结束播放: ended

    // IOS事件顺序: loadedmetadata(duration开始有值)
    // IOS点击播放: play、loadeddata(仅第一次)、playing、timeupdate
    // IOS点击暂停: pause
    // IOS结束播放: ended

    // Android事件顺序:loadedmetadata(部分duration开始有值,Galaxy Note3 Lite 4G 4.3)、loadeddata、timeupdate
    // Android点击播放: play、playing、timeupdate(部分duration开始有值,vivo X5S L 4.4.4)
    // Android点击暂停: pause
    // Android结束播放: ended

    // 当元数据（比如分辨率和时长）被加载时运行的脚本。
    self.audio.addEventListener('loadedmetadata', function () {
      self.settings.debug && _utils2.default._appendDebug('p', 'loadedmetadata' + self.audio.duration);
      self.setTimeTotal(self.audio.duration);
    });
    // 当媒介数据已加载时运行的脚本。
    self.audio.addEventListener('loadeddata', function () {
      self.settings.debug && _utils2.default._appendDebug('p', 'loadeddata' + self.audio.duration);
      self.setTimeTotal(self.audio.duration);
    });
    // 当媒介已开始播放时运行的脚本。
    self.audio.addEventListener('playing', function () {
      self.settings.debug && _utils2.default._appendDebug('p', 'playing' + self.audio.duration);
      self.setTimeTotal(self.audio.duration);
    });
    // 当播放位置改变时（比如当用户快进到媒介中一个不同的位置时）运行的脚本。
    self.audio.addEventListener('timeupdate', function () {
      self.setTimeTotal(self.audio.duration);
      self.timeCurrent.innerText = self.secondsToTime(self.audio.currentTime);
      var percentage = self.audio.currentTime / self.audio.duration * 100 + '%';
      self.barPlaying.style.width = percentage;
      self.barHandler.style.left = percentage;
    });
    // 当媒介已到达结尾时运行的脚本（可发送类似“感谢观看”之类的消息）。
    self.audio.addEventListener('ended', function () {
      self.settings.debug && _utils2.default._appendDebug('p', 'ended');
      _utils2.default.removeClass(self.player, 'audio-playing');
      if (self.settings.autoplay && window.audioArr.length > self.settings.index + 1) {
        window.pausePlayingAudio();
        _utils2.default.addClass(window.audioArr[self.settings.index + 1].player, 'audio-playing');
        window.audioArr[self.settings.index + 1].audio.play();
      }
    });
    // 当媒介已就绪可以开始播放时运行的脚本。
    self.audio.addEventListener('play', function () {
      self.settings.debug && _utils2.default._appendDebug('p', 'play');
    });
    // 当媒介被用户或程序暂停时运行的脚本。
    self.audio.addEventListener('pause', function () {
      self.settings.debug && _utils2.default._appendDebug('p', 'pause');
    });

    self.theBar.addEventListener(eStart, function (e) {
      self.adjustCurrentTime(e);
      self.theBar.addEventListener(eMove, function (e) {
        self.adjustCurrentTime(e);
      });
    });
    self.theBar.addEventListener(eEnd, function () {
      self.theBar.removeEventListener(eMove, null);
    });

    self.barHandler.addEventListener(eStart, function (e) {
      self.barHandler.addEventListener(eMove, function (e) {
        self.adjustCurrentTime(e);
        // 阻止事件冒泡到theBar move事件上
        // 如不加会在IOS 8会产生影响,导致无法滑动
        e.preventDefault();
        e.stopPropagation();
      });
    });
    self.barHandler.addEventListener(eEnd, function () {
      self.barHandler.removeEventListener(eMove, null);
    });

    self.player.querySelector('.audio-switch').addEventListener('click', function () {
      if (_utils2.default.hasClass(self.player, 'audio-playing')) {
        _utils2.default.removeClass(self.player, 'audio-playing');
        self.audio.pause();
      } else {
        window.pausePlayingAudio();
        _utils2.default.addClass(self.player, 'audio-playing');
        self.audio.play();
      }
    });
  },
  // 调节当前播放时间
  adjustCurrentTime: function adjustCurrentTime(e) {
    var self = this;
    if (e.originalEvent) e = e.originalEvent;
    var theRealEvent = _utils2.default.support.touch ? e.touches[0] : e;
    self.audio.currentTime = Math.round(self.audio.duration * (theRealEvent.pageX - self.theBar.offsetLeft) / self.theBar.clientWidth);
  },
  // 设置总时间
  setTimeTotal: function setTimeTotal(duration) {
    var self = this;
    if (duration > 0 && !self.timeTotal.getAttribute('duration')) {
      self.timeTotal.setAttribute('duration', duration);
      self.timeTotal.innerText = self.secondsToTime(self.audio.duration);
    }
  },
  // 将秒转换成固定格式的时间
  secondsToTime: function secondsToTime(secs) {
    var hours = Math.floor(secs / 3600);
    var minutes = Math.floor(secs % 3600 / 60);
    var seconds = Math.ceil(secs % 3600 % 60);
    return (hours === 0 ? '' : hours > 0 && hours.toString().length < 2 ? '0' + hours + ':' : hours + ':') + (minutes.toString().length < 2 ? '0' + minutes : minutes) + ':' + (seconds.toString().length < 2 ? '0' + seconds : seconds);
  },
  // android 兼容性有问题,需要优化
  canPlayType: function canPlayType(file) {
    var audioElement = document.createElement('audio');
    return !!(audioElement.canPlayType && audioElement.canPlayType('audio/' + file.split('.').pop().toLowerCase() + ';').replace(/no/, ''));
  }
};
exports.default = audioPlayer;
module.exports = exports['default'];

/***/ }),
/* 65 */
/***/ (function(module, exports) {

// removed by extract-text-webpack-plugin

/***/ }),
/* 66 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

__webpack_require__(67);

var _utils = __webpack_require__(0);

var _utils2 = _interopRequireDefault(_utils);

var _eventBus = __webpack_require__(2);

var _eventBus2 = _interopRequireDefault(_eventBus);

var _transition = __webpack_require__(31);

var _transition2 = _interopRequireDefault(_transition);

var _extends = __webpack_require__(3);

var _extends2 = _interopRequireDefault(_extends);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// touch事件
var touchEvents = {
  start: _utils2.default.support.touch ? 'touchstart' : 'mousedown',
  move: _utils2.default.support.touch ? 'touchmove' : 'mousemove',
  end: _utils2.default.support.touch ? 'touchend' : 'mouseup'
};

var Swiper = function Swiper(el, options) {
  this.wrapper = typeof el === 'string' ? document.querySelector(el) : el;
  this.scroller = this.wrapper.querySelector('.bx-swiper-scroller');
  var defaults = {
    // 轮播组件的宽度,默认设备宽度
    width: null,
    // 轮播组件的高度, default、min、auto、数值
    height: null,
    // 轮播间隔事件
    speed: 5000,
    // 是否循环轮播
    loop: true,
    // 是否自动轮播
    autoplay: true,
    // 轮播动画时间
    transitionSpeed: 300,
    // 是否展示指示器/分页器
    pagination: true,
    // 页数大于当前值时,才展示分页器
    paginationLimit: 1,
    // 覆盖默认指示器/分页器样式
    paginationClass: null,
    // 指示器/分页器距离底部的距离
    paginationBottom: 9,
    // 滑动角度小于该值,才能正常滑动
    angle: 45,
    // 滑动结束后,时间小于{duration}毫秒并且距离大于{distance},即判定为滑动到上一个/下一个
    duration: 300,
    distance: 30,
    // 放大倍数, 根据viewport动态设置scale的值, 基本为1
    scale: null,
    // 是否开启回弹
    bounce: true,
    // 轮播相关事件
    onInit: _utils2.default.noop,
    onTouchStart: _utils2.default.noop,
    onTouchMove: _utils2.default.noop,
    onTouchEnd: _utils2.default.noop,
    onSlide: _utils2.default.noop,
    onSlidePrev: _utils2.default.noop,
    onSlideNext: _utils2.default.noop,
    onTransitionEnd: _utils2.default.noop
  };
  this.options = defaults;
  (0, _extends2.default)(this.options, options);
  this.options.$parent = this;
  this.computedWidth = this.options.width;
  this.total = 0;
  this.loopTotal = 0;
  this.currentIndex = 0;
  this.timer = null;
  this.isTouchStart = false;
  this.isTouchEnd = false;
  this.direction = null;
  this.distance = 0;
  this.offset = {
    x: 0, // 横向滑动距离
    y: 0 // 纵向滑动距离
  };
  this.touches = {
    startX: 0, // touch前一个点
    startY: 0, // touch前一个点
    currentX: 0, // touch后一个点
    currentY: 0, // touch后一个点
    distanceX: 0, // 两个touch之间的距离
    distanceY: 0 // 两个touch之间的距离
  };
  this.unique = this.options.unique || _utils2.default.getUnique();
  this.init();
};
var startTime = 0;
var endTime = 0;
var duration = 0;
var isTouchEvent = false;
var isTouch = false;
var isSliding;
Swiper.prototype = {
  init: function init() {
    var self = this;
    self.setWidth();
    self.setHeight();
    self.setIndex();
    self.setScale();
    self.total = self.getTotal();
    if (self.options.pagination && self.total > self.options.paginationLimit) {
      self.initPagination();
    }
    self.total <= 1 && (self.options.loop = false);
    self.options.loop && self.createLoop();
    self.options.autoplay && self.startInterval(self.options.speed);
    self.observer = _eventBus2.default.create(self.unique);
    self._addEvent();
    self.observer.emit('onInit');
  },
  // 设置容器宽度
  setWidth: function setWidth() {
    var self = this;
    var _width = 0;

    if (self.options.width) {
      self.wrapper.style.width = _utils2.default.isPercentage(self.options.width) ? self.options.width : self.options.width + 'px';
    }
    _width = self.wrapper.clientWidth;
    self.computedWidth = _width;
  },
  // 设置容器高度
  setHeight: function setHeight() {
    var self = this;
    if (self.options.height) {
      if (_utils2.default.isPercentage(self.options.height)) {
        self.wrapper.style['height'] = self.computedWidth * _utils2.default.percentageToNumber(self.options.height) + 'px';
      } else {
        self.wrapper.style['height'] = self.options.height + 'px';
      }
    } else {
      self.wrapper.style['height'] = '100%';
    }
  },
  // 设置元素放大倍数
  setScale: function setScale() {
    var self = this;
    if (!self.options.scale) {
      self.options.scale = _utils2.default.getScale();
    }
  },
  // autopaly为true,开启轮播定时器
  startInterval: function startInterval(speed) {
    var self = this;
    self.timer = window.setInterval(function () {
      if (self.isTouchStart) {
        if (self.isTouchEnd) {
          self.isTouchStart = false;
          self.isTouchEnd = false;
        }
        return false;
      }
      self.next();
    }, speed);
  },
  // 获取当前轮播个数
  getTotal: function getTotal() {
    var self = this;
    var items = self.wrapper.querySelectorAll('.bx-swiper-slide');
    return items.length;
  },
  // 设置轮播项index
  setIndex: function setIndex() {
    var self = this;
    var items = self.wrapper.querySelectorAll('.bx-swiper-slide');
    for (var index = 0; index < items.length; index++) {
      items[index].setAttribute('data-slide-index', index);
    }
  },
  // 获取当前轮播项index
  getIndex: function getIndex() {
    var self = this;
    var items = self.wrapper.querySelectorAll('.bx-swiper-slide');
    var currentIndex = 0;
    for (var index = 0; index < items.length; index++) {
      if (_utils2.default.hasClass(items[index], 'bx-swiper-slide--active')) {
        currentIndex = items[index].getAttribute('data-slide-index');
      }
    }
    return currentIndex;
  },
  // 滚动到指定的x轴/y轴位置, time为动画时间
  slideTo: function slideTo(x, y, time) {
    var self = this;
    _transition2.default.setProperty(self.scroller, _transition2.default.prefixStyle('transform'));
    time !== 0 && (time = self.options.transitionSpeed);
    _transition2.default.setDuration(self.scroller, time);
    self._translate(x, y);
  },
  // 滚动到指定的index
  slideToIndex: function slideToIndex(index, type) {
    var self = this;
    if (self.options.loop) {
      if (type === 'prev') {
        if (index === self.total - 1) {
          self.slideTo(0, 0);
        } else {
          self.slideTo(-1 * (index + 1) * self.computedWidth, 0);
        }
      } else {
        if (index === 0) {
          self.slideTo(-1 * (self.loopTotal - 1) * self.computedWidth, 0);
        } else {
          self.slideTo(-1 * (index + 1) * self.computedWidth, 0);
        }
      }
    } else {
      self.slideTo(-1 * index * self.computedWidth, 0);
    }

    self.setItemActive();
    self.options.pagination && self.setPaginationActive();
    self.observer.emit('onSlide');
  },
  // 更新index位置
  updateIndex: function updateIndex() {
    var self = this;
    if (self.options.loop) {
      self.slideTo(-1 * (self.currentIndex + 1) * self.computedWidth, 0, 0);
    } else {
      self.slideTo(-1 * self.currentIndex * self.computedWidth, 0, 0);
    }
  },
  // 设置当前index的轮播项为活动状态
  setItemActive: function setItemActive() {
    var self = this;
    var items = self.wrapper.querySelectorAll('.bx-swiper-slide');
    for (var index = 0; index < items.length; index++) {
      if (items[index].getAttribute('data-slide-index') === self.currentIndex) {
        !_utils2.default.hasClass(items[index], 'bx-swiper-slide--active') && _utils2.default.addClass(items[index], 'bx-swiper-slide--active');
      } else {
        _utils2.default.hasClass(items[index], 'bx-swiper-slide--active') && _utils2.default.removeClass(items[index], 'bx-swiper-slide--active');
      }
    }
  },
  // 初始化指示器/分页器
  initPagination: function initPagination() {
    var self = this;
    var div = document.createElement('div');
    div.className = self.options.paginationClass ? 'bx-swiper-paginations ' + self.options.paginationClass : 'bx-swiper-paginations';
    var html = '';
    for (var i = 0; i < self.total; i++) {
      html += '<div class="bx-swiper-pagination' + (i === 0 ? ' bx-swiper-pagination--active' : '') + '"></div>';
    }
    div.innerHTML = html;
    // 使用该方案, 分页器会模糊
    // div.style.bottom = (self.options.paginationBottom * self.options.scale) + 'px';
    // self.options.scale != 1 && Utils.setScale(div, self.options.scale);
    div.style.bottom = self.options.paginationBottom / self.options.scale + 'px';
    self.options.scale !== 1 && (div.style.zoom = self.options.scale);
    self.wrapper.appendChild(div);
  },
  // 设置当前index的指示器/分页器为活动状态
  setPaginationActive: function setPaginationActive() {
    var self = this;
    var items = self.wrapper.querySelectorAll('.bx-swiper-pagination');
    for (var index = 0; index < items.length; index++) {
      if (index === self.currentIndex) {
        !_utils2.default.hasClass(items[index], 'bx-swiper-pagination--active') && _utils2.default.addClass(items[index], 'bx-swiper-pagination--active');
        !_utils2.default.hasClass(items[index], 'bx-swiper-pagination--translation') && _utils2.default.addClass(items[index], 'bx-swiper-pagination--translation');
      } else {
        _utils2.default.hasClass(items[index], 'bx-swiper-pagination--active') && _utils2.default.removeClass(items[index], 'bx-swiper-pagination--active');
        _utils2.default.hasClass(items[index], 'bx-swiper-pagination--translation') && _utils2.default.removeClass(items[index], 'bx-swiper-pagination--translation');
      }
    }
  },
  // 滑动到上一个
  prev: function prev() {
    var self = this;
    self.currentIndex--;
    if (self.currentIndex < 0) {
      self.currentIndex = self.total - 1;
    }
    self.slideToIndex(self.currentIndex, 'prev');
    self.observer.emit('onSlidePrev');
  },
  // 滑动到下一个
  next: function next() {
    var self = this;
    self.currentIndex++;
    if (self.currentIndex >= self.total) {
      self.currentIndex = 0;
    }
    self.slideToIndex(self.currentIndex, 'next');
    self.observer.emit('onSlideNext');
  },
  // 初始化循环滚动
  createLoop: function createLoop() {
    var self = this;
    var items = self.wrapper.querySelectorAll('.bx-swiper-slide');
    var firstNode = items[0].cloneNode(true);
    _utils2.default.removeClass(firstNode, 'bx-swiper-slide--active');
    var lastNode = items[items.length - 1].cloneNode(true);
    self.scroller.insertBefore(lastNode, items[0]);
    self.scroller.appendChild(firstNode);
    self.loopTotal = self.getTotal();
    // 定位到第一个slideitem
    self._translate(-1 * self.computedWidth, 0);
  },
  // 处理循环滚动位置
  handleLoop: function handleLoop() {
    var self = this;
    if (self.offset.x === 0) {
      self.slideTo(-1 * self.total * self.computedWidth, 0, 0);
    }
    if (self.offset.x === -1 * (self.loopTotal - 1) * self.computedWidth) {
      self.slideTo(-1 * self.computedWidth, 0, 0);
    }
  },
  // 统一事件处理中心
  handleEvent: function handleEvent(e) {
    switch (e.type) {
      case 'touchstart':
        this._onTouchStart(e);
        break;
      case 'touchmove':
        this._onTouchMove(e);
        break;
      case 'touchend':
        this._onTouchEnd(e);
        break;
      case 'mousedown':
        this._onTouchStart(e);
        break;
      case 'mousemove':
        this._onTouchMove(e);
        break;
      case 'mouseup':
        this._onTouchEnd(e);
        break;
      case 'transitionend':
        this._transitionEnd(e);
        break;
      case 'webkitTransitionEnd':
        this._transitionEnd(e);
        break;
      case 'resize':
        this._onResize(e);
        break;
    }
  },
  // 判断是否需要回弹
  setBounce: function setBounce() {
    var self = this;
    if (!self.options.loop) {
      if (self.currentIndex === 0 && self.direction === 'right') {
        return true;
      }
      if (self.currentIndex === self.total - 1 && self.direction === 'left') {
        return true;
      }
    }
    return false;
  },
  // 添加事件
  _addEvent: function _addEvent() {
    var self = this;
    this.wrapper['addEventListener'](touchEvents.start, this, false);
    this.wrapper['addEventListener'](touchEvents.move, this, false);
    this.wrapper['addEventListener'](touchEvents.end, this, false);
    if (_utils2.default.support.touch && !_utils2.default.env.isIos && !_utils2.default.env.isAndroid) {
      this.wrapper['addEventListener']('mousedown', this, false);
      this.wrapper['addEventListener']('mousemove', this, false);
      this.wrapper['addEventListener']('mouseup', this, false);
    }
    this.scroller['addEventListener']('transitionend', this, false);
    this.scroller['addEventListener']('webkitTransitionEnd', this, false);
    window['addEventListener']('resize', this, false);
    for (var item in self.options) {
      if (item.indexOf('on') === 0) {
        if (self.options[item] instanceof Function) {
          (function (item, _self) {
            _self.observer.on(item, function () {
              _self.options[item].apply(_self, Array.prototype.slice.call(arguments));
            });
          })(item, self);
        }
      }
    }
  },
  _onTouchStart: function _onTouchStart(e) {
    var self = this;
    // 兼容jq自己封装的originalEvent,指向原始的事件对象
    if (e.originalEvent) e = e.originalEvent;
    // 大于一个touch点,不做处理
    if (e.touches && e.touches.length > 1) {
      e.preventDefault();
      return;
    }
    isTouchEvent = e.type === 'touchstart';
    isTouch = true;
    isSliding = undefined;
    self.touches.startX = isTouchEvent ? e.touches[0].pageX : e.pageX;
    self.touches.startY = isTouchEvent ? e.touches[0].pageY : e.pageY;
    startTime = _utils2.default.now();
    self.distance = 0;
    self.isTouchStart = true;
    _transition2.default.setDuration(self.scroller, 0);
    self.observer.emit('onTouchStart');
  },
  _onTouchMove: function _onTouchMove(e) {
    var self = this;
    if (e.originalEvent) e = e.originalEvent;
    if (!isTouch && e.type === 'mousemove') {
      e.preventDefault();
      return;
    }
    self.options.loop && self.handleLoop();
    if (e.touches && e.touches.length > 1) {
      e.preventDefault();
      return;
    }
    self.touches.currentX = e.type === 'touchmove' ? e.touches[0].pageX : e.pageX;
    self.touches.currentY = e.type === 'touchmove' ? e.touches[0].pageY : e.pageY;
    var touchAngle = Math.atan2(Math.abs(self.touches.currentY - self.touches.startY), Math.abs(self.touches.currentX - self.touches.startX)) * 180 / Math.PI;
    if (typeof isSliding === 'undefined') {
      isSliding = touchAngle <= self.options.angle;
    }
    if (!isSliding) {
      return;
    }
    self.touches.distanceX = self.touches.currentX - self.touches.startX;
    self.touches.distanceY = self.touches.currentY - self.touches.startY;
    self.touches.distanceX > 0 ? self.direction = 'right' : self.direction = 'left';
    self.options.bounce && (self.bounce = self.setBounce());
    self.bounce && (self.touches.distanceX = self.touches.distanceX / 2);
    self.offset.x += self.touches.distanceX;
    self.distance += self.touches.distanceX;
    self._translate(self.offset.x, 0);
    self.touches.startX = self.touches.currentX;
    self.touches.startY = self.touches.currentY;
    e.preventDefault();
    self.observer.emit('onTouchMove');
  },
  _onTouchEnd: function _onTouchEnd(e) {
    var self = this;
    endTime = _utils2.default.now();
    duration = endTime - startTime;
    if (!self.bounce && (duration <= self.options.duration && Math.abs(self.distance) > self.options.distance || Math.abs(self.distance) > self.computedWidth / 2)) {
      self.distance > 0 ? self.prev() : self.next();
    } else {
      self.slideTo(self.offset.x - self.distance, 0);
    }
    isTouch = false;
    self.isTouchEnd = true;
    self.observer.emit('onTouchEnd');
  },
  _onResize: function _onResize(e) {
    var self = this;
    self.setWidth();
    self.setHeight();
    self.updateIndex();
  },
  // transition动画结束后回调
  _transitionEnd: function _transitionEnd(e) {
    var self = this;
    self.options.loop && self.handleLoop();
    self.observer.emit('onTransitionEnd');
  },
  // 页面滑动到指定位置
  _translate: function _translate(x, y) {
    var self = this;
    if (!self.options.bounce) {
      if (x > 0) {
        x = 0;
      }
      var total = self.options.loop ? self.loopTotal : self.total;
      var totalDistance = (total - 1) * self.computedWidth;
      if (Math.abs(x) > totalDistance) {
        x = -1 * totalDistance;
      }
    }
    self.offset.x = x;
    _transition2.default.setTransform(self.scroller, x, y);
  }
};
exports.default = {
  create: function create(el, options) {
    return new Swiper(el, options);
  }
};
module.exports = exports['default'];

/***/ }),
/* 67 */
/***/ (function(module, exports) {

// removed by extract-text-webpack-plugin

/***/ }),
/* 68 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

__webpack_require__(69);

var _utils = __webpack_require__(0);

var _utils2 = _interopRequireDefault(_utils);

var _transition = __webpack_require__(31);

var _transition2 = _interopRequireDefault(_transition);

var _eventBus = __webpack_require__(2);

var _eventBus2 = _interopRequireDefault(_eventBus);

var _extends = __webpack_require__(3);

var _extends2 = _interopRequireDefault(_extends);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var touchEvents = {
  start: _utils2.default.support.touch ? 'touchstart' : 'mousedown',
  move: _utils2.default.support.touch ? 'touchmove' : 'mousemove',
  end: _utils2.default.support.touch ? 'touchend' : 'mouseup'
};
var startTime = 0;
var endTime = 0;
var duration = 0;
var isTouchEvent = false;
var isTouch = false;
var isSliding;
var Tab = function Tab(el, options) {
  this.wrapper = typeof el === 'string' ? document.querySelector(el) : el;
  this.contents = this.wrapper.querySelector('.bx-tab-contents');
  this.scroller = this.wrapper.querySelector('.bx-tab-scroller');
  this.line = null;
  var defaults = {
    width: null,
    lineWidth: 22,
    scale: null,
    slide: true,
    transition: true,
    transitionSpeed: 300,
    bounce: true,
    angle: 45,
    activeIndex: 0,
    onInit: _utils2.default.noop(),
    onSlidePrev: _utils2.default.noop,
    onSlideNext: _utils2.default.noop,
    onChange: _utils2.default.noop(),
    onTabClick: _utils2.default.noop()
  };
  this.options = defaults;
  (0, _extends2.default)(this.options, options);
  this.options.$parent = this;
  this.total = 0;
  this.currentIndex = this.options.activeIndex || 0;
  this.direction = null;
  this.offset = {
    x: 0, // 横向滑动距离
    y: 0 // 纵向滑动距离
  };
  this.touches = {
    startX: 0, // touch前一个点
    startY: 0, // touch前一个点
    currentX: 0, // touch后一个点
    currentY: 0, // touch后一个点
    distanceX: 0, // 两个touch之间的距离
    distanceY: 0 // 两个touch之间的距离
  };
  this.distance = 0;
  this.singleContent = false;
  this.unique = this.options.unique || _utils2.default.getUnique();
  this.init();
};
Tab.prototype = {
  init: function init() {
    var self = this;
    self.setWidth();
    self.setScale();
    self.setSlide();
    self.total = self.getTotal();
    self.observer = _eventBus2.default.create(self.unique);
    self.line = new Line(self.wrapper.querySelector('.bx-tab-line'), {
      unique: self.unique,
      total: self.total,
      width: self.options.lineWidth,
      containerWidth: self.computedWidth
    });
    self.line.setParent(self);
    self._addEvent();
    self.goToIndex(self.currentIndex, 0);
    self.observer.emit('onInit');
  },
  // 设置容器宽度
  setWidth: function setWidth() {
    var self = this;
    var _width = 0;
    if (self.options.width) {
      self.wrapper.style.width = _utils2.default.isPercentage(self.options.width) ? self.options.width : self.options.width + 'px';
    }
    _width = self.wrapper.clientWidth;
    self.computedWidth = _width;
  },
  // 设置元素放大倍数
  setScale: function setScale() {
    var self = this;
    if (!self.options.scale) {
      self.options.scale = _utils2.default.getScale();
    }
    this.wrapper.querySelector('.bx-tab-wrap').style['zoom'] = self.options.scale;
  },
  getTotal: function getTotal() {
    var self = this;
    var items = self.wrapper.querySelectorAll('.bx-tab-item');
    return items.length;
  },
  setSlide: function setSlide() {
    var self = this;
    var items = self.wrapper.querySelectorAll('.bx-tab-content');
    if (items.length <= 1) {
      self.options.slide = false;
      self.options.transition = false;
      self.singleContent = true;
    }
  },
  slideTo: function slideTo(x, y, time) {
    var self = this;
    _transition2.default.setProperty(self.scroller, _transition2.default.prefixStyle('transform'));
    time !== 0 && (time = self.options.transitionSpeed);
    self.options.slide || self.options.transition || (time = 0);
    _transition2.default.setDuration(self.scroller, time);
    self._translate(x, y);
  },
  slideToIndex: function slideToIndex(index) {
    var self = this;
    self.slideTo(-1 * index * self.computedWidth, 0);
    self.setContentActive();
  },
  clickToIndex: function clickToIndex(index) {
    var self = this;
    self.goToIndex(index);
  },
  goToIndex: function goToIndex(index, time) {
    var self = this;
    self.setTabActive();
    self.setContentActive();
    self.singleContent ? self.slideTo(0, 0, 0) : self.slideTo(-1 * index * self.computedWidth, 0, time);
    self.line.clickToIndex(index, time);
  },
  setTabActive: function setTabActive() {
    var self = this;
    var items = self.wrapper.querySelectorAll('.bx-tab-item');
    for (var index = 0; index < items.length; index++) {
      if (index === self.currentIndex) {
        !_utils2.default.hasClass(items[index], 'bx-tab--active') && _utils2.default.addClass(items[index], 'bx-tab--active');
      } else {
        _utils2.default.hasClass(items[index], 'bx-tab--active') && _utils2.default.removeClass(items[index], 'bx-tab--active');
      }
    }
    self.observer.emit('onChange', self.currentIndex);
  },
  setContentActive: function setContentActive() {
    var self = this;
    var items = self.wrapper.querySelectorAll('.bx-tab-content');
    if (self.singleContent) {
      !_utils2.default.hasClass(items[0], 'bx-tab-content--active') && _utils2.default.addClass(items[0], 'bx-tab-content--active');
    } else {
      for (var index = 0; index < items.length; index++) {
        if (index === self.currentIndex) {
          !_utils2.default.hasClass(items[index], 'bx-tab-content--active') && _utils2.default.addClass(items[index], 'bx-tab-content--active');
        } else {
          _utils2.default.hasClass(items[index], 'bx-tab-content--active') && _utils2.default.removeClass(items[index], 'bx-tab-content--active');
        }
      }
    }
  },
  prev: function prev() {
    var self = this;
    self.currentIndex--;
    if (self.currentIndex < 0) {
      self.currentIndex = 0;
    }
    self.observer.emit('onSlidePrev');
    self.slideToIndex(self.currentIndex);
    self.line.slideToIndex(self.currentIndex);
  },
  next: function next() {
    var self = this;
    self.currentIndex++;
    if (self.currentIndex >= self.total) {
      self.currentIndex = self.total - 1;
    }
    self.observer.emit('onSlideNext');
    self.slideToIndex(self.currentIndex);
    self.line.slideToIndex(self.currentIndex);
  },
  handleEvent: function handleEvent(e) {
    switch (e.type) {
      case 'click':
        this._onItemClick(e);
        break;
      case 'touchstart':
        this._onTouchStart(e);
        break;
      case 'touchmove':
        this._onTouchMove(e);
        break;
      case 'touchend':
        this._onTouchEnd(e);
        break;
      case 'mousedown':
        this._onTouchStart(e);
        break;
      case 'mousemove':
        this._onTouchMove(e);
        break;
      case 'mouseup':
        this._onTouchEnd(e);
        break;
      case 'transitionend':
        this._transitionEnd(e);
        break;
      case 'webkitTransitionEnd':
        this._transitionEnd(e);
        break;
      case 'resize':
        this._onResize(e);
        break;
    }
  },
  // 判断是否需要回弹
  setBounce: function setBounce() {
    var self = this;
    if (self.currentIndex === 0 && self.direction === 'right' && self.offset.x > 0) {
      return true;
    }
    if (self.currentIndex === self.total - 1 && self.direction === 'left' && Math.abs(self.offset.x) > (self.total - 1) * self.computedWidth) {
      return true;
    }
    return false;
  },
  _addEvent: function _addEvent() {
    var self = this;
    if (self.options.slide) {
      self.contents['addEventListener'](touchEvents.start, this, false);
      self.contents['addEventListener'](touchEvents.move, this, false);
      self.contents['addEventListener'](touchEvents.end, this, false);
      self.scroller['addEventListener']('transitionend', this, false);
      self.scroller['addEventListener']('webkitTransitionEnd', this, false);
    }
    window['addEventListener']('resize', this, false);
    self._addClick();
    self.observer.on('setTabActive', function () {
      self.setTabActive();
    });
    for (var item in self.options) {
      if (item.indexOf('on') === 0) {
        if (self.options[item] instanceof Function) {
          (function (item, _self) {
            _self.observer.on(item, function () {
              _self.options[item].apply(_self, Array.prototype.slice.call(arguments));
            });
          })(item, self);
        }
      }
    }
  },
  _addClick: function _addClick() {
    var self = this;
    var items = self.wrapper.querySelectorAll('.bx-tab-item');
    for (var i = 0; i < items.length; i++) {
      (function (index) {
        items[index]['addEventListener']('click', function (e) {
          self._onItemClick(e, index);
        }, false);
      })(i);
    }
  },
  _onItemClick: function _onItemClick(e, index) {
    var self = this;
    self.currentIndex = index;
    self.observer.emit('onItemClick', index);
    self.clickToIndex(index);
  },
  _onTouchStart: function _onTouchStart(e) {
    var self = this;
    // 兼容jq自己封装的originalEvent,指向原始的事件对象
    if (e.originalEvent) e = e.originalEvent;
    // 大于一个touch点,不做处理
    if (e.touches && e.touches.length > 1) {
      e.preventDefault();
      return;
    }
    isTouchEvent = e.type === 'touchstart';
    isTouch = true;
    isSliding = undefined;
    self.touches.startX = isTouchEvent ? e.touches[0].clientX : e.clientX;
    self.touches.startY = isTouchEvent ? e.touches[0].clientY : e.clientY;
    startTime = _utils2.default.now();
    self.distance = 0;
    self.line.touchStart();
    _transition2.default.setDuration(self.scroller, 0);
  },
  _onTouchMove: function _onTouchMove(e) {
    var self = this;
    if (e.originalEvent) e = e.originalEvent;
    if (!isTouch && e.type === 'mousemove') {
      e.preventDefault();
      return;
    }
    if (e.touches && e.touches.length > 1) {
      e.preventDefault();
      return;
    }
    self.touches.currentX = e.type === 'touchmove' ? e.touches[0].clientX : e.clientX;
    self.touches.currentY = e.type === 'touchmove' ? e.touches[0].clientY : e.clientY;
    var touchAngle = Math.atan2(Math.abs(self.touches.currentY - self.touches.startY), Math.abs(self.touches.currentX - self.touches.startX)) * 180 / Math.PI;
    if (typeof isSliding === 'undefined') {
      isSliding = touchAngle <= self.options.angle;
    }
    if (!isSliding) {
      return;
    }
    self.touches.distanceX = self.touches.currentX - self.touches.startX;
    self.touches.distanceX > 0 ? self.direction = 'right' : self.direction = 'left';
    self.options.bounce && (self.bounce = self.setBounce());
    self.bounce && (self.touches.distanceX = self.touches.distanceX / 2);
    self.offset.x += self.touches.distanceX;
    self.distance += self.touches.distanceX;
    self._translate(self.offset.x, 0);
    self.line.touchMove(self.touches.distanceX, self.distance);

    self.touches.startX = self.touches.currentX;
    self.touches.startY = self.touches.currentY;

    e.preventDefault();
  },
  _onTouchEnd: function _onTouchEnd(e) {
    var self = this;
    endTime = _utils2.default.now();
    duration = endTime - startTime;
    if (!self.bounce && (duration <= 300 && Math.abs(self.distance) > 30 || Math.abs(self.distance) > self.computedWidth / 2)) {
      self.distance > 0 ? self.prev() : self.next();
    } else {
      self.slideTo(self.offset.x - self.distance, 0);
      self.line.stretchTo(self.line.options.width);
    }
    isTouch = false;
  },
  _onResize: function _onResize(e) {
    var self = this;
    self.setWidth();
    self.slideTo(-1 * self.currentIndex * self.computedWidth, 0, 0);
    self.line.options.containerWidth = self.computedWidth;
    self.line._onResize(e);
  },
  // transition动画结束后回调
  _transitionEnd: function _transitionEnd(e) {},
  // 页面滑动到指定位置
  _translate: function _translate(x, y) {
    var self = this;
    if (!self.options.bounce) {
      if (x > 0) {
        x = 0;
      }
      var totalDistance = (self.total - 1) * self.computedWidth;
      if (Math.abs(x) > totalDistance) {
        x = -1 * totalDistance;
      }
    }
    self.offset.x = x;
    _transition2.default.setTransform(self.scroller, x, y);
  }
};

var Line = function Line(el, options) {
  this.el = typeof el === 'string' ? document.querySelector(el) : el;
  this.options = {
    width: 22,
    speed: 200,
    total: 1,
    containerWidth: null
  };
  (0, _extends2.default)(this.options, options);
  this.unique = this.options.unique || _utils2.default.getUnique();
  this.init();
};
Line.prototype = {
  parent: null,
  currentIndex: 0,
  direction: null,
  distance: 0,
  isTransition: false,
  positionType: 'left',
  init: function init() {
    var self = this;
    self.setScale();
    self.setWidth();
    self.setPosition();
    self.observer = _eventBus2.default.create(self.unique);
    self.addEvent();
  },
  setWidth: function setWidth() {
    var self = this;
    if (self.options.width) {
      self.el.style.width = self.options.width + 'px';
    }
    self.tabWidth = self.options.containerWidth / self.options.total;
    self.maxWidth = self.tabWidth + self.options.width;
  },
  // 设置元素放大倍数
  setScale: function setScale() {
    var self = this;
    if (!self.options.scale) {
      self.options.scale = _utils2.default.getScale();
    }
    self.options.width = self.options.scale * self.options.width;
    self.el.style['height'] = self.el.clientHeight * self.options.scale + 'px';
  },
  setParent: function setParent(obj) {
    this.parent = obj;
  },
  setDirection: function setDirection(distance) {
    var self = this;
    self.direction = distance < 0 ? 'right' : 'left';
  },
  setPosition: function setPosition(type, index) {
    var self = this;
    (index === undefined || index === null) && (index = self.currentIndex);
    var tabWidth = self.options.containerWidth / self.options.total;
    var left = (tabWidth - self.options.width) / 2 + index * tabWidth;
    var right = self.options.containerWidth - left - self.options.width;
    self.positionType = type || 'left';
    if (type === 'right') {
      self.el.style['right'] = right + 'px';
      self.el.style['left'] = 'auto';
    } else {
      self.el.style['left'] = left + 'px';
      self.el.style['right'] = 'auto';
    }
  },
  touchStart: function touchStart() {
    var self = this;
    self.distance = 0;
  },
  touchMove: function touchMove(x) {
    var self = this;
    self.distance += 2 * x / self.options.total;
    self.setDirection(self.distance);
    // 边界判断
    if (self.currentIndex === 0 && self.direction === 'left' || self.currentIndex === self.options.total - 1 && self.direction === 'right') {
      return;
    }

    var width = 0;
    var index = self.currentIndex;
    var direction = self.direction;
    var distance = Math.abs(self.distance);
    if (distance >= self.tabWidth) {
      distance >= 2 * self.tabWidth && (distance = 2 * self.tabWidth);
      width = self.options.width + 2 * self.tabWidth - distance;
      index = self.direction === 'left' ? self.currentIndex - 1 : self.currentIndex + 1;
    } else {
      width = self.options.width + distance;
      direction = self.direction === 'left' ? 'right' : 'left';
    }
    self.setPosition(direction, index);
    self.stretchTo(width, 0);
  },
  stretchTo: function stretchTo(width, time) {
    var self = this;
    _transition2.default.setProperty(self.el, 'width');
    time !== 0 && time === undefined && (time = self.options.speed);
    _transition2.default.setDuration(self.el, time);
    // 强制开启硬件加速
    _transition2.default.setTransform(self.el, 0, 0);
    self.el.style.width = width + 'px';
  },
  moveTo: function moveTo(index, time) {
    var self = this;
    _transition2.default.setProperty(self.el, self.positionType);
    time !== 0 && time === undefined && (time = self.options.speed);
    _transition2.default.setDuration(self.el, time);
    self.currentIndex = index;
    self.setPosition(self.positionType);
  },
  slideToIndex: function slideToIndex(index) {
    var self = this;
    if (self.currentIndex === 0 && self.direction === 'left' || self.currentIndex === self.options.total - 1 && self.direction === 'right') {
      return;
    }
    self.currentIndex = index;
    var width = self.options.width;
    if (Math.abs(self.distance) < self.tabWidth) {
      self.isTransition = true;
      width = self.maxWidth;
    }
    self.stretchTo(width);
    self.observer.emit('setTabActive');
  },
  clickToIndex: function clickToIndex(index, time) {
    var self = this;
    self.moveTo(index, time);
  },
  prev: function prev() {
    var self = this;
    self.currentIndex--;
    if (self.currentIndex < 0) {
      self.currentIndex = 0;
    }
    self.slideToIndex(self.currentIndex);
  },
  next: function next() {
    var self = this;
    self.currentIndex++;
    if (self.currentIndex >= self.options.total) {
      self.currentIndex = self.options.total - 1;
    }
    self.slideToIndex(self.currentIndex);
  },
  addEvent: function addEvent() {
    var self = this;
    self.el['addEventListener']('transitionend', this, false);
    self.el['addEventListener']('webkitTransitionEnd', this, false);
  },
  handleEvent: function handleEvent(e) {
    var self = this;
    switch (e.type) {
      case 'transitionend':
        self._transitionEnd(e);
        break;
      case 'webkitTransitionEnd':
        self._transitionEnd(e);
        break;
    }
  },
  _onResize: function _onResize(e) {
    var self = this;
    self.setWidth();
    self.setPosition();
  },
  _transitionEnd: function _transitionEnd(e) {
    var self = this;
    if (self.isTransition) {
      self.setPosition(self.direction);
      self.stretchTo(self.options.width, self.options.speed);
      self.isTransition = false;
    }
  }
};
exports.default = Tab;
module.exports = exports['default'];

/***/ }),
/* 69 */
/***/ (function(module, exports) {

// removed by extract-text-webpack-plugin

/***/ }),
/* 70 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _utils = __webpack_require__(0);

var _utils2 = _interopRequireDefault(_utils);

var _eventBus = __webpack_require__(2);

var _eventBus2 = _interopRequireDefault(_eventBus);

var _extends = __webpack_require__(3);

var _extends2 = _interopRequireDefault(_extends);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var touchEvents = {
  start: _utils2.default.support.touch ? 'touchstart' : 'mousedown',
  move: _utils2.default.support.touch ? 'touchmove' : 'mousemove',
  end: _utils2.default.support.touch ? 'touchend' : 'mouseup'
}; // 借鉴
// https://github.com/szimek/signature_pad

var isTouchEvent = false;
var isTouch = false;
var Signature = function Signature(el, options) {
  this.wrapper = typeof el === 'string' ? document.querySelector(el) : el;
  var defaults = {
    lineWidth: 3,
    penColor: '#000',
    backgroundColor: '#FFF',
    placeholder: '请在白色区域内 横向签名',
    onInit: _utils2.default.noop,
    onBegin: _utils2.default.noop,
    onUpdate: _utils2.default.noop,
    onEnd: _utils2.default.noop
  };
  this.options = defaults;
  (0, _extends2.default)(this.options, options);
  this.unique = this.options.unique || _utils2.default.getUnique();
  this.touches = {};
  this.clearPlaceholder = false;
  this.isPainted = false;
  this._init();
};
Signature.prototype = {
  _init: function _init() {
    var self = this;
    self._createCanvas();
    self.setPlaceholder();
    self.observer = _eventBus2.default.create(self.unique);
    self._addEvent();
    self.observer.emit('onInit');
  },
  _createCanvas: function _createCanvas() {
    var self = this;
    var _wrapper = self.wrapper;
    var _canvas = document.createElement('canvas');
    var _ctx = _canvas.getContext('2d');
    _wrapper.appendChild(_canvas);
    self._canvas = _canvas;
    self._ctx = _ctx;
    self._setCanvas();
  },
  _setCanvas: function _setCanvas() {
    var self = this;
    var _wrapper = self.wrapper;
    var _canvas = self._canvas;
    var _ctx = self._ctx;
    var _options = self.options;
    _canvas.width = _wrapper.clientWidth;
    _canvas.height = _wrapper.clientHeight;
    _ctx.lineWidth = _options.lineWidth;
    _ctx.strokeStyle = _options.penColor;
    _ctx.fillStyle = self.options.backgroundColor;
    _ctx.fillRect(0, 0, _canvas.width, _canvas.height);
    self.rect = _canvas.getBoundingClientRect();
  },
  _addEvent: function _addEvent() {
    var self = this;
    self._canvas['addEventListener'](touchEvents.start, this, false);
    self._canvas['addEventListener'](touchEvents.move, this, false);
    self._canvas['addEventListener'](touchEvents.end, this, false);
    window['addEventListener']('resize', this, false);
    for (var item in self.options) {
      if (item.indexOf('on') === 0) {
        if (self.options[item] instanceof Function) {
          (function (item, _self) {
            _self.observer.on(item, function () {
              _self.options[item].apply(_self, Array.prototype.slice.call(arguments));
            });
          })(item, self);
        }
      }
    }
  },
  _onTouchStart: function _onTouchStart(e) {
    var self = this;
    if (e.originalEvent) e = e.originalEvent;
    isTouchEvent = e.type === 'touchstart';
    var touch = isTouchEvent ? e.touches[0] : e;
    isTouch = true;
    self.clearPlaceholder || self.clear();
    self.clearPlaceholder = true;
    self._strokeBegin(touch);
    self.isPainted = true;
    e.preventDefault();
  },
  _onTouchMove: function _onTouchMove(e) {
    var self = this;
    if (e.originalEvent) e = e.originalEvent;
    if (!isTouch && e.type === 'mousemove') {
      e.preventDefault();
      return;
    }
    var touch = isTouchEvent ? e.touches[0] : e;
    self._strokeUpdate(touch);
    e.preventDefault();
  },
  _onTouchEnd: function _onTouchEnd(e) {
    var self = this;
    if (e.originalEvent) e = e.originalEvent;
    var touch = isTouchEvent ? e.touches[0] : e;
    self._strokeEnd(touch);
    isTouch = false;
    e.preventDefault();
  },
  _onResize: function _onResize(e) {
    var self = this;
    self._setCanvas();
    self.reset();
  },
  _strokeBegin: function _strokeBegin(touch) {
    var self = this;
    self.touches.startX = touch.clientX;
    self.touches.startY = touch.clientY;
    self._strokeUpdate(touch);
    self.observer.emit('onBegin', touch);
  },
  _strokeUpdate: function _strokeUpdate(touch) {
    var self = this;
    var _touches = self.touches;
    _touches.currentX = touch.clientX;
    _touches.currentY = touch.clientY;
    var start = self._createPoint(_touches.startX, _touches.startY);
    var end = self._createPoint(_touches.currentX, _touches.currentY);
    self._drawLine(start, end);
    _touches.startX = touch.clientX;
    _touches.startY = touch.clientY;
    self.observer.emit('onUpdate', touch);
  },
  _strokeEnd: function _strokeEnd(touch) {
    var self = this;
    self.observer.emit('onEnd', touch);
  },
  _createPoint: function _createPoint(x, y) {
    var self = this;
    var _offset = self.rect;
    return {
      x: x - _offset.left,
      y: y - _offset.top
    };
  },
  _drawLine: function _drawLine(start, end) {
    var self = this;
    var _ctx = self._ctx;
    _ctx.beginPath();
    _ctx.moveTo(start.x, start.y);
    _ctx.lineTo(end.x, end.y);
    _ctx.closePath();
    _ctx.stroke();
  },
  handleEvent: function handleEvent(e) {
    var self = this;
    switch (e.type) {
      case 'touchstart':
        self._onTouchStart(e);
        break;
      case 'touchmove':
        self._onTouchMove(e);
        break;
      case 'touchend':
        self._onTouchEnd(e);
        break;
      case 'mousedown':
        self._onTouchStart(e);
        break;
      case 'mousemove':
        self._onTouchMove(e);
        break;
      case 'mouseup':
        self._onTouchEnd(e);
        break;
      case 'resize':
        this._onResize(e);
        break;
    }
  },
  setPlaceholder: function setPlaceholder(placeholder) {
    var self = this;
    var _ctx = self._ctx;
    var _canvas = self._canvas;
    _ctx.font = '300 15px PingFang SC';
    _ctx.textAlign = 'center';
    _ctx.textBaseline = 'middle';
    _ctx.fillStyle = '#ccc';
    placeholder = placeholder || self.options.placeholder;
    _ctx.fillText(self.options.placeholder, _canvas.width / 2, _canvas.height / 2);
  },
  clear: function clear() {
    var self = this;
    var _canvas = self._canvas;
    var _ctx = self._ctx;
    _ctx.fillStyle = self.options.backgroundColor;
    _ctx.clearRect(0, 0, _canvas.width, _canvas.height);
    _ctx.fillRect(0, 0, _canvas.width, _canvas.height);
  },
  reset: function reset() {
    var self = this;
    self.clear();
    self.clearPlaceholder = false;
    self.isPainted = false;
    self.setPlaceholder();
  },
  toImage: function toImage(type, quality) {
    var self = this;
    if (!self.isPainted) {
      return;
    }
    type = type || 'image/png';
    quality = quality || 0.92;
    return self._canvas.toDataURL(type, quality);
  }
};

exports.default = Signature;
module.exports = exports['default'];

/***/ }),
/* 71 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _utils = __webpack_require__(0);

var _utils2 = _interopRequireDefault(_utils);

var _eventBus = __webpack_require__(2);

var _eventBus2 = _interopRequireDefault(_eventBus);

var _image = __webpack_require__(72);

var _image2 = _interopRequireDefault(_image);

var _extends = __webpack_require__(3);

var _extends2 = _interopRequireDefault(_extends);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// 参考借鉴
// http://www.w3school.com.cn/xmldom/dom_http.asp
// https://github.com/Tencent/weui.js/blob/master/src/uploader/upload.js
var Uploader = function Uploader(el, options) {
  this.wrapper = typeof el === 'string' ? document.querySelector(el) : el;
  var defaults = {
    url: null,
    type: 'POST',
    async: true,
    data: {},
    headers: {},
    xhrFields: {},
    compress: {
      type: 'image/png',
      quality: '0.92',
      width: null,
      height: null
    },
    base64: null,
    autoUpload: true,
    fileType: [],
    onInit: _utils2.default.noop,
    onBefore: _utils2.default.noop,
    onSuccess: _utils2.default.noop,
    onError: _utils2.default.noop,
    onComplete: _utils2.default.noop,
    onProgress: _utils2.default.noop
  };
  this.options = defaults;
  (0, _extends2.default)(this.options, options);
  this.unique = this.options.unique || _utils2.default.getUnique();
  this._init();
};
Uploader.prototype = {
  _init: function _init() {
    var self = this;
    self.observer = _eventBus2.default.create(self.unique);
    self._addEvent();
    self.observer.emit('onInit');
    self.options.base64 && self._sendBase64();
  },
  _addEvent: function _addEvent() {
    var self = this;
    if (!self.options.base64) {
      var $wrapper = self.wrapper;
      $wrapper.querySelector('input[type="file"]').addEventListener('change', function (event) {
        self._onChange(event);
      }, false);
    }
    for (var item in self.options) {
      if (item.indexOf('on') === 0) {
        if (self.options[item] instanceof Function) {
          (function (item, _self) {
            _self.observer.on(item, function () {
              _self.options[item].apply(_self, Array.prototype.slice.call(arguments));
            });
          })(item, self);
        }
      }
    }
  },
  _onChange: function _onChange(event) {
    var self = this;
    var _files = event.target.files;
    if (_files.length === 0) {
      return;
    }
    self.files = _files;
    if (!self._isLegalType(self.files[0])) {
      return false;
    }
    self._handleImage(self.files[0], function (file) {
      self.file = file;
      self.observer.emit('onBefore', file);
      self.options.autoUpload && self._sendXHR(file);
    });
  },
  _sendXHR: function _sendXHR(file) {
    var self = this;
    var _xhr = new XMLHttpRequest();
    self._xhr = _xhr;
    var _options = self.options;
    self._setFormDate(file);
    self._setXhrFields();
    _xhr.onreadystatechange = function () {
      self._onReadyStateChange();
    };
    _xhr.upload.onprogress = function (event) {
      self._onProgress(event);
    };
    _xhr.open(_options.type, _options.url, _options.async);
    self._setHeaders();
    _xhr.send(self._formData);
  },
  _sendBase64: function _sendBase64() {
    var self = this;
    var blob = _image2.default.dataURItoBlob(self.options.base64);
    self.file = blob;
    self.observer.emit('onBefore', blob);
    self.options.autoUpload && self._sendXHR(blob);
  },
  _onReadyStateChange: function _onReadyStateChange() {
    var self = this;
    var _xhr = self._xhr;
    var response = '';
    // readyState, http://www.w3school.com.cn/xmldom/dom_http.asp
    // 0,Uninitialized,初始化状态。XMLHttpRequest 对象已创建或已被 abort() 方法重置。
    // 1,Open,open() 方法已调用，但是 send() 方法未调用。请求还没有被发送。
    // 2,Sent,Send() 方法已调用，HTTP 请求已发送到 Web 服务器。未接收到响应。
    // 3,Receiving,所有响应头部都已经接收到。响应体开始接收但未完成。
    // 4,Loaded,HTTP 响应已经完全接收。
    if (_xhr.readyState === 4) {
      if (_xhr.status === 200) {
        try {
          _xhr.responseText && (response = JSON.parse(_xhr.responseText));
          self.observer.emit('onSuccess', response);
        } catch (error) {
          self.observer.emit('onError', _xhr, _xhr.status, error);
        }
      } else {
        self.observer.emit('onError', _xhr, _xhr.status, _xhr.statusText);
      }
      self.observer.emit('onComplete', _xhr);
      _xhr.abort();
    }
  },
  _onProgress: function _onProgress(event) {
    var self = this;
    if (event.total === 0) return;
    var percent = Math.ceil(event.loaded / event.total) * 100;
    self.observer.emit('onProgress', percent);
  },
  _setFormDate: function _setFormDate(file) {
    var self = this;
    var _formData = new FormData();
    var _data = self.options.data;
    for (var key in _data) {
      _formData.append(key, _data[key]);
    }
    _formData.append('file', file);
    self._formData = _formData;
  },
  _setHeaders: function _setHeaders() {
    var self = this;
    var _xhr = self._xhr;
    var _headers = self.options.headers;
    for (var key in _headers) {
      _xhr.setRequestHeader(key, _headers[key]);
    }
  },
  _setXhrFields: function _setXhrFields() {
    var self = this;
    var _xhr = self._xhr;
    var _xhrFields = self.options.xhrFields;
    for (var key in _xhrFields) {
      _xhr[key] = _xhrFields[key];
    }
  },
  _handleImage: function _handleImage(file, callback) {
    var self = this;
    var reader = new FileReader();
    reader.onload = function (event) {
      self._imageToBlob(file, event, callback);
    };
    reader.readAsDataURL(file);
  },
  _imageToBlob: function _imageToBlob(file, event, callback) {
    var self = this;
    var img = new Image();
    img.src = event.target.result;
    img.onload = function () {
      // var ratio = ImageHelper.detectVerticalSquash(img);
      var orientation = _image2.default.getOrientation(_image2.default.dataURItoBuffer(img.src));
      var canvas = document.createElement('canvas');
      var ctx = canvas.getContext('2d');
      var width = img.width;
      var height = img.height;
      var maxW = self.options.compress.width;
      var maxH = self.options.compress.height;
      if (maxH && width < height && height > maxH) {
        width = parseInt(maxH * img.width / img.height);
        height = maxH;
      } else if (maxW && width >= height && width > maxW) {
        height = parseInt(maxW * img.height / img.width);
        width = maxW;
      }
      canvas.width = width;
      canvas.height = height;
      if (orientation > 0) {
        _image2.default.orientationHelper(canvas, ctx, orientation);
      }
      ctx.drawImage(img, 0, 0, width, height);
      var dataURL = canvas.toDataURL(self.options.compress.type, self.options.compress.quality);
      if (/;base64,null/.test(dataURL) || /;base64,$/.test(dataURL)) {
        callback(file);
      } else {
        var blob = _image2.default.dataURItoBlob(dataURL);
        blob.name = file.name;
        blob.lastModified = file.lastModified;
        blob.lastModifiedDate = file.lastModifiedDate;
        callback(blob);
      }
    };
  },
  _isLegalType: function _isLegalType(file) {
    var self = this;
    var _fileType = self.options.fileType;
    _fileType || (_fileType = []);
    if (_fileType.length <= 0) {
      _fileType.push('jpg');
      _fileType.push('jpeg');
      _fileType.push('png');
      _fileType.push('gif');
      _fileType.push('bmp');
      _fileType.push('svg');
    }
    for (var i = 0; i < _fileType.length; i++) {
      if (file.type.toLowerCase().indexOf(_fileType[i]) !== -1) {
        return true;
      }
    }
    self.observer.emit('onError', null, 404, '请上传指定格式文件');
    return false;
  },
  upload: function upload() {
    var self = this;
    self._sendXHR(self.file);
  }
};
exports.default = Uploader;
module.exports = exports['default'];

/***/ }),
/* 72 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
/* eslint-disable */
// 来源
// https://github.com/Tencent/weui.js/blob/master/src/uploader/image.js
var ImageHelper = {
  // 检查图片是否有被压扁，如果有，返回比率
  // ref to http://stackoverflow.com/questions/11929099/html5-canvas-drawimage-ratio-bug-ios
  detectVerticalSquash: function detectVerticalSquash(img) {
    // 拍照在IOS7或以下的机型会出现照片被压扁的bug
    var data;
    var ih = img.naturalHeight;
    var canvas = document.createElement('canvas');
    canvas.width = 1;
    canvas.height = ih;
    var ctx = canvas.getContext('2d');
    ctx.drawImage(img, 0, 0);
    try {
      data = ctx.getImageData(0, 0, 1, ih).data;
    } catch (err) {
      console.log('Cannot check verticalSquash: CORS?');
      return 1;
    }
    var sy = 0;
    var ey = ih;
    var py = ih;
    while (py > sy) {
      var alpha = data[(py - 1) * 4 + 3];
      if (alpha === 0) {
        ey = py;
      } else {
        sy = py;
      }
      py = ey + sy >> 1; // py = parseInt((ey + sy) / 2)
    }
    var ratio = py / ih;
    return ratio === 0 ? 1 : ratio;
  },
  // dataURI to blob
  // ref to https://gist.github.com/fupslot/5015897
  dataURItoBuffer: function dataURItoBuffer(dataURI) {
    var byteString = atob(dataURI.split(',')[1]);
    var buffer = new ArrayBuffer(byteString.length);
    var view = new Uint8Array(buffer);
    for (var i = 0; i < byteString.length; i++) {
      view[i] = byteString.charCodeAt(i);
    }
    return buffer;
  },
  dataURItoBlob: function dataURItoBlob(dataURI) {
    var mimeString = dataURI.split(',')[0].split(':')[1].split(';')[0];
    var buffer = this.dataURItoBuffer(dataURI);
    return new Blob([buffer], { type: mimeString });
  },
  // 获取图片的orientation
  // ref to http://stackoverflow.com/questions/7584794/accessing-jpeg-exif-rotation-data-in-javascript-on-the-client-side
  getOrientation: function getOrientation(buffer) {
    var view = new DataView(buffer);
    if (view.getUint16(0, false) != 0xFFD8) return -2;
    var length = view.byteLength,
        offset = 2;
    while (offset < length) {
      var marker = view.getUint16(offset, false);
      offset += 2;
      if (marker == 0xFFE1) {
        if (view.getUint32(offset += 2, false) != 0x45786966) return -1;
        var little = view.getUint16(offset += 6, false) == 0x4949;
        offset += view.getUint32(offset + 4, little);
        var tags = view.getUint16(offset, little);
        offset += 2;
        for (var i = 0; i < tags; i++) {
          if (view.getUint16(offset + i * 12, little) == 0x0112) return view.getUint16(offset + i * 12 + 8, little);
        }
      } else if ((marker & 0xFF00) != 0xFF00) break;else offset += view.getUint16(offset, false);
    }
    return -1;
  },
  // 修正拍照时图片的方向
  // ref to https://stackoverflow.com/questions/19463126/how-to-draw-photo-with-correct-orientation-in-canvas-after-capture-photo-by-usin
  orientationHelper: function orientationHelper(canvas, ctx, orientation) {
    var w = canvas.width;
    var h = canvas.height;
    if (orientation > 4) {
      canvas.width = h;
      canvas.height = w;
    }
    switch (orientation) {
      case 2:
        ctx.translate(w, 0);
        ctx.scale(-1, 1);
        break;
      case 3:
        ctx.translate(w, h);
        ctx.rotate(Math.PI);
        break;
      case 4:
        ctx.translate(0, h);
        ctx.scale(1, -1);
        break;
      case 5:
        ctx.rotate(0.5 * Math.PI);
        ctx.scale(1, -1);
        break;
      case 6:
        ctx.rotate(0.5 * Math.PI);
        ctx.translate(0, -h);
        break;
      case 7:
        ctx.rotate(0.5 * Math.PI);
        ctx.translate(w, -h);
        ctx.scale(-1, 1);
        break;
      case 8:
        ctx.rotate(-0.5 * Math.PI);
        ctx.translate(-w, 0);
        break;
    }
  }
};
exports.default = ImageHelper;
module.exports = exports['default'];

/***/ })
/******/ ]);
});